#eddy dowle
#supplmentary two 
#Parasitological research in the molecular age

#this code details bring in the files from web of science
#assigning the research from parasitology into either human or non-human
#cleans up keywords
#plots word clouds
#plots networks
#plots sankey plot

#for code on maps see
#https://github.com/eddydowle/shinyparasitesthroughtime
#for a interactive map plot type:
#if(!require('shiny'))install.packages('shiny');
#library('shiny')
#runGitHub( "shinyparasitesthroughtime", "eddydowle")


library(bibliometrix)
library(tidyverse)

#change to your working directory
setwd("~/Documents/parasitebibsearch/")

#modified read function from biblio
readFilesmod<-function (...) 
{
  arguments <- as.list(...) 
  k = length(arguments)
  D = list()
  enc = "UTF-8"
  for (i in 1:k) {
    D[[i]] = suppressWarnings(readLines(arguments[[i]], encoding = enc))
  }
  D = unlist(D)
  return(D)
}

#bring in data from all parasites
#this code assumes all three subsets are in different file locations
#allozyme
file_list<-list.files(path='AllozymeData/',pattern='*.bib',full.names=T)
citations_genomics_P<-readFilesmod(dput(as.character(file_list))) 
citations_df_genomics_P_alo<- citations_df_genomics_P 

#nucleotide
file_list<-list.files(path='NucleotideData/',pattern='.*.bib',full.names=T)
citations_genomics_P<-readFilesmod(dput(as.character(file_list))) 
citations_df_genomics_P_nuc<- citations_df_genomics_P 

#genomics
file_list<-list.files(path='GenomicData/',pattern='.*.bib',full.names=T)
citations_genomics_P<-readFilesmod(dput(as.character(file_list))) 
citations_df_genomics_P_gen<- citations_df_genomics_P 

#create column labeled medical
citations_df_genomics_P_alo$medical<-'Not Medical'
citations_df_genomics_P_nuc$medical<-'Not Medical'
citations_df_genomics_P_gen$medical<-'Not Medical'

#citations_df_genomics_P_nuc
#citations_df_genomics_P_gen

#**# asign papers to medical when feilds DE,AB,TI, or ID have a match from the following
citations_df_genomics_P_alo<-citations_df_genomics_P_alo %>%  mutate(medical=ifelse(grepl('human|[[:blank:]]man[[:blank:]]|woman|child|[[:blank:]]men[[:blank:]]|women|person|people|medical|patient|[[:blank:]]man\\.|[[:blank:]]men\\.|zoonotic|infant|public[[:blank:]]health|congenital[[:blank:]]+toxoplasmosis|ocular[[:blank:]]+toxoplasmosis|zoonosis|foodborne[[:blank:]]+illness|foodborne[[:blank:]]+disease|[[:blank:]]HIV[[:blank:]]|[[:blank:]]HIV\\.|[[:blank:]]HIV,|[[:blank:]]HIV-1|[[:blank:]]+aids\\.|blood[[:blank:]]+donor|world[[:blank:]]+health[[:blank:]]+organisation|world[[:blank:]]+health[[:blank:]]+organization|Anopheles|mosquito|encephalitis|^man[[:blank:]]+|^men[[:blank:]]+|^HIV[[:blank:]]+|^aids[[:blank:]]+|^HIV-1|immunodeficiency', DE,ignore.case=T)|grepl('human|[[:blank:]]man[[:blank:]]|woman|child|[[:blank:]]men[[:blank:]]|women|person|people|medical|patient|[[:blank:]]man\\.|[[:blank:]]men\\.|zoonotic|infant|public[[:blank:]]health|congenital[[:blank:]]+toxoplasmosis|ocular[[:blank:]]+toxoplasmosis|zoonosis|foodborne[[:blank:]]+illness|foodborne[[:blank:]]+disease|[[:blank:]]HIV[[:blank:]]|[[:blank:]]HIV\\.|[[:blank:]]HIV,|[[:blank:]]HIV-1|[[:blank:]]+aids\\.|blood[[:blank:]]+donor|world[[:blank:]]+health[[:blank:]]+organisation|world[[:blank:]]+health[[:blank:]]+organization|Anopheles|mosquito|encephalitis|^man[[:blank:]]+|^men[[:blank:]]+|^HIV[[:blank:]]+|^aids[[:blank:]]+|^HIV-1|immunodeficiency', AB,ignore.case=T)|grepl('human|[[:blank:]]man[[:blank:]]|woman|child|[[:blank:]]men[[:blank:]]|women|person|people|medical|patient|[[:blank:]]man\\.|[[:blank:]]men\\.|zoonotic|infant|public[[:blank:]]health|congenital[[:blank:]]+toxoplasmosis|ocular[[:blank:]]+toxoplasmosis|zoonosis|foodborne[[:blank:]]+illness|foodborne[[:blank:]]+disease|[[:blank:]]HIV[[:blank:]]|[[:blank:]]HIV\\.|[[:blank:]]HIV,|[[:blank:]]HIV-1|[[:blank:]]+aids\\.|blood[[:blank:]]+donor|world[[:blank:]]+health[[:blank:]]+organisation|world[[:blank:]]+health[[:blank:]]+organization|Anopheles|mosquito|encephalitis|^man[[:blank:]]+|^men[[:blank:]]+|^HIV[[:blank:]]+|^aids[[:blank:]]+|^HIV-1|immunodeficiency', TI,ignore.case=T)|grepl('human|[[:blank:]]man[[:blank:]]|woman|child|[[:blank:]]men[[:blank:]]|women|person|people|medical|patient|[[:blank:]]man\\.|[[:blank:]]men\\.|zoonotic|infant|public[[:blank:]]health|congenital[[:blank:]]+toxoplasmosis|ocular[[:blank:]]+toxoplasmosis|zoonosis|foodborne[[:blank:]]+illness|foodborne[[:blank:]]+disease|[[:blank:]]HIV[[:blank:]]|[[:blank:]]HIV\\.|[[:blank:]]HIV,|[[:blank:]]HIV-1|[[:blank:]]+aids\\.|blood[[:blank:]]+donor|world[[:blank:]]+health[[:blank:]]+organisation|world[[:blank:]]+health[[:blank:]]+organization|Anopheles|mosquito|encephalitis|^man[[:blank:]]+|^men[[:blank:]]+|^HIV[[:blank:]]+|^aids[[:blank:]]+|^HIV-1|immunodeficiency', ID,ignore.case=T),'Medical',medical))

#**# include in 'medical' all the other human related parasites terms defined a priori for the retreat
citations_df_genomics_P_alo<-citations_df_genomics_P_alo %>%  mutate(medical=ifelse(grepl('human[[:blank:]]+parasit|plasmodium|malaria|trypanosoma[[:blank:]]+cruzi|chagas|trypanosoma-cruzi|trypanosoma[[:blank:]]+brucei|trypanosoma-brucei|sleeping[[:blank:]]+sickness|sleep[[:blank:]]+fever|African[[:blank:]]+trypanosomiasis|Leishmania|Schistosomias|schistosoma|Bilharzia|Cysticercosis|Taenia|Echinococcosis|hydatidosis|Echinococcus[[:blank:]]+granulosus|Lymphatic[[:blank:]]+filariasis|Wuchereria|Brugia[[:blank:]]+malayi|Brugia[[:blank:]]+timori|Onchocerc|Onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness|Ascaris|Ascariasis|Trichuri|whipworm|Hookworm|Ancylostoma[[:blank:]]+duodenale|Necator[[:blank:]]+americanus|fasciola|Dracuncul|Guinea[[:blank:]]+Worm', DE,ignore.case=T)|grepl('human[[:blank:]]+parasit|plasmodium|malaria|trypanosoma[[:blank:]]+cruzi|chagas|trypanosoma-cruzi|trypanosoma[[:blank:]]+brucei|trypanosoma-brucei|sleeping[[:blank:]]+sickness|sleep[[:blank:]]+fever|African[[:blank:]]+trypanosomiasis|Leishmania|Schistosomias|schistosoma|Bilharzia|Cysticercosis|Taenia|Echinococcosis|hydatidosis|Echinococcus[[:blank:]]+granulosus|Lymphatic[[:blank:]]+filariasis|Wuchereria|Brugia[[:blank:]]+malayi|Brugia[[:blank:]]+timori|Onchocerc|Onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness|Ascaris|Ascariasis|Trichuri|whipworm|Hookworm|Ancylostoma[[:blank:]]+duodenale|Necator[[:blank:]]+americanus|fasciola|Dracuncul|Guinea[[:blank:]]+Worm', AB,ignore.case=T)|grepl('human[[:blank:]]+parasit|plasmodium|malaria|trypanosoma[[:blank:]]+cruzi|chagas|trypanosoma-cruzi|trypanosoma[[:blank:]]+brucei|trypanosoma-brucei|sleeping[[:blank:]]+sickness|sleep[[:blank:]]+fever|African[[:blank:]]+trypanosomiasis|Leishmania|Schistosomias|schistosoma|Bilharzia|Cysticercosis|Taenia|Echinococcosis|hydatidosis|Echinococcus[[:blank:]]+granulosus|Lymphatic[[:blank:]]+filariasis|Wuchereria|Brugia[[:blank:]]+malayi|Brugia[[:blank:]]+timori|Onchocerc|Onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness|Ascaris|Ascariasis|Trichuri|whipworm|Hookworm|Ancylostoma[[:blank:]]+duodenale|Necator[[:blank:]]+americanus|fasciola|Dracuncul|Guinea[[:blank:]]+Worm', TI,ignore.case=T)|grepl('human[[:blank:]]+parasit|plasmodium|malaria|trypanosoma[[:blank:]]+cruzi|chagas|trypanosoma-cruzi|trypanosoma[[:blank:]]+brucei|trypanosoma-brucei|sleeping[[:blank:]]+sickness|sleep[[:blank:]]+fever|African[[:blank:]]+trypanosomiasis|Leishmania|Schistosomias|schistosoma|Bilharzia|Cysticercosis|Taenia|Echinococcosis|hydatidosis|Echinococcus[[:blank:]]+granulosus|Lymphatic[[:blank:]]+filariasis|Wuchereria|Brugia[[:blank:]]+malayi|Brugia[[:blank:]]+timori|Onchocerc|Onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness|Ascaris|Ascariasis|Trichuri|whipworm|Hookworm|Ancylostoma[[:blank:]]+duodenale|Necator[[:blank:]]+americanus|fasciola|Dracuncul|Guinea[[:blank:]]+Worm', ID,ignore.case=T),'Medical',medical))


#**# malaria assignment (note back assingment for avian malaria and reptilian malaria)
citations_df_genomics_P_alo<-citations_df_genomics_P_alo %>%  mutate(medical=ifelse(grepl('plasmodium[[:blank:]]+falciparum|plasmodium[[:blank:]]+vivax|plasmodium[[:blank:]]+malariae|plasmodium +ovale|plasmodium[[:blank:]]+knowlesi|entamoeba[[:blank:]]+histolytica|lyme[[:blank:]]+disease|borrelia[[:blank:]]+burgdorferi|lymphatic[[:blank:]]+filariasis|wuchereria|brugia[[:blank:]]+malayi|brugia[[:blank:]]+timori|onchocerc|onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness|ascaris[[:blank:]]+lumbricoides|ascariasis|trichuri|whipworm|hookworm|ancylostoma[[:blank:]]+duodenale|necator[[:blank:]]+americanus|fasciol|dracuncul|guinea[[:blank:]]+worm', DE,ignore.case=T)|grepl('plasmodium[[:blank:]]+falciparum|plasmodium[[:blank:]]+vivax|plasmodium[[:blank:]]+malariae|plasmodium +ovale|plasmodium[[:blank:]]+knowlesi|entamoeba[[:blank:]]+histolytica|lyme[[:blank:]]+disease|borrelia[[:blank:]]+burgdorferi|lymphatic[[:blank:]]+filariasis|wuchereria|brugia[[:blank:]]+malayi|brugia[[:blank:]]+timori|onchocerc|onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness|ascaris[[:blank:]]+lumbricoides|ascariasis|trichuri|whipworm|hookworm|ancylostoma[[:blank:]]+duodenale|necator[[:blank:]]+americanus|fasciol|dracuncul|guinea[[:blank:]]+worm', AB,ignore.case=T)|grepl('plasmodium[[:blank:]]+falciparum|plasmodium[[:blank:]]+vivax|plasmodium[[:blank:]]+malariae|plasmodium +ovale|plasmodium[[:blank:]]+knowlesi|entamoeba[[:blank:]]+histolytica|lyme[[:blank:]]+disease|borrelia[[:blank:]]+burgdorferi|lymphatic[[:blank:]]+filariasis|wuchereria|brugia[[:blank:]]+malayi|brugia[[:blank:]]+timori|onchocerc|onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness|ascaris[[:blank:]]+lumbricoides|ascariasis|trichuri|whipworm|hookworm|ancylostoma[[:blank:]]+duodenale|necator[[:blank:]]+americanus|fasciol|dracuncul|guinea[[:blank:]]+worm', TI,ignore.case=T)|grepl('plasmodium[[:blank:]]+falciparum|plasmodium[[:blank:]]+vivax|plasmodium[[:blank:]]+malariae|plasmodium +ovale|plasmodium[[:blank:]]+knowlesi|entamoeba[[:blank:]]+histolytica|lyme[[:blank:]]+disease|borrelia[[:blank:]]+burgdorferi|lymphatic[[:blank:]]+filariasis|wuchereria|brugia[[:blank:]]+malayi|brugia[[:blank:]]+timori|onchocerc|onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness|ascaris[[:blank:]]+lumbricoides|ascariasis|trichuri|whipworm|hookworm|ancylostoma[[:blank:]]+duodenale|necator[[:blank:]]+americanus|fasciol|dracuncul|guinea[[:blank:]]+worm', ID,ignore.case=T),'Medical',medical)) 
citations_df_genomics_P_alo<-citations_df_genomics_P_alo %>%  mutate(medical=ifelse(grepl('avian[[:blank:]]+malaria', DE,ignore.case=T)|grepl('pavian[[:blank:]]+malaria', AB,ignore.case=T)|grepl('avian[[:blank:]]+malaria', TI,ignore.case=T)|grepl('avian[[:blank:]]+malaria', ID,ignore.case=T),'Not Medical',medical))
citations_df_genomics_P_alo<-citations_df_genomics_P_alo %>%  mutate(medical=ifelse(grepl('reptilian[[:blank:]]+malaria', DE,ignore.case=T)|grepl('Reptilian[[:blank:]]+malaria', AB,ignore.case=T)|grepl('reptilian[[:blank:]]+malaria', TI,ignore.case=T)|grepl('reptilian[[:blank:]]+malaria', ID,ignore.case=T),'Not Medical',medical))  

#repeat the above steps for genomic and nucleotide
#citations_df_genomics_P_nuc
#citations_df_genomics_P_gen


citations_df_genomics_P_alo %>% filter(.,medical=='Medical') %>% nrow()
citations_df_genomics_P_nuc %>% filter(.,medical=='Medical') %>% nrow()
citations_df_genomics_P_gen %>% filter(.,medical=='Medical') %>% nrow()



###########code for cumulative publication plots###########
# all parasites
citations_ana_allozyme_P <- citations_df_genomics_P_alo %>% select(-medical) %>% biblioAnalysis(., sep = ";")
citations_ana.sum_allozyme_P <- summary(object = citations_ana_allozyme_P, k = 100, pause = FALSE)

df1_allozyme_P<-citations_ana.sum_allozyme_P$AnnualProduction %>% mutate(cumsum=cumsum(Articles),cumper=cumsum(Articles)/sum(Articles)*100)
colnames(df1_allozyme_P) <- c("Year", "ArticlesP.allozyme","cumsumP.allozyme","cumperP.allozyme")
x.10_P.allozyme<-df1_allozyme_P %>% slice(which.min(abs(.$cumperP.allozyme - 10))) %>% .$Year %>% as.character() %>% as.numeric()
df1_allozyme_P$Year<-as.character(df1_allozyme_P$Year)

# medical parasites
citations_df_allozyme_med<-citations_df_genomics_P_alo %>% filter(.,medical=='Medical') 
citations_df_allozyme_P.med_ana <- citations_df_allozyme_med %>% select(-medical) %>% biblioAnalysis(., sep = ";")
citations_df_allozyme_P.med.sum <- summary(object = citations_df_allozyme_P.med_ana, k = 100, pause = FALSE)

df1_allozyme_med<-citations_df_allozyme_P.med.sum$AnnualProduction %>% mutate(cumsum=cumsum(Articles),cumper=cumsum(Articles)/sum(Articles)*100)
colnames(df1_allozyme_med) <- c("Year", "ArticlesP.med.allozyme","cumsumP.med.allozyme","cumperP.med.allozyme")
x.10_P.med.allozyme<-df1_allozyme_med %>% slice(which.min(abs(.$cumperP.med.allozyme - 10))) %>% .$Year %>% as.character() %>% as.numeric()
df1_allozyme_med$Year<-as.character(df1_allozyme_med$Year)



## Broad search data
#bring in data from general search
d1v2_allozyme<-read.table('./AllozymeData/All/AllozymePerYearBroadSearch.txt', sep="\t",header=T,row.names=NULL)
head(d1v2_allozyme)

colnames(d1v2_allozyme) <- c("Year", "Articles", "cumsum")
d1v2_allozyme<-d1v2_allozyme %>%  arrange(.,Year) %>%  mutate(cumsum=cumsum(Articles),cumper=cumsum(Articles)/sum(Articles)*100)
colnames(d1v2_allozyme) <- c("Year", "ArticlesGeneral.allozyme", "cumsum.allozyme","cumper.allozyme")
x.10perAll.allozyme<-d1v2_allozyme %>% slice(which.min(abs(.$cumper.allozyme - 10))) %>% .$Year %>% as.character() %>% as.numeric()
d1v2_allozyme$Year <- as.character(d1v2_allozyme$Year)

#repeat the above steps for genomic and nucleotide



## Cumulative plots
set.seed(1)
list.of.data.frames = list(d1v2_allozyme, df1_allozyme_P, df1_allozyme_med,d1v2_nucleotide, df1_nucleotide_P, df1_nucleotide_med, d1v2_genomics, df1_genomics_P, df1_genomics_med)
dmerged= Reduce(function(...) merge(...,by='Year', all=T), list.of.data.frames)
head(dmerged)

#NA should be 0
dmerged[is.na(dmerged)] <- 0 
dmerged$Year<-as.integer(dmerged$Year)

# General vs Parasites
dmerged %>% select(.,ArticlesGeneral.allozyme,ArticlesP.allozyme,ArticlesGeneral.nucleotide,ArticlesP.nucleotide,ArticlesGeneral.genomics,ArticlesP.genomics,Year) %>% filter(.,Year > 1959 & Year!=2018 & Year!=2019) %>% tidyr::gather("id", "value", 1:6) %>% ggplot(aes(Year, value)) + 
#  geom_point(aes(colour = factor(id)),size = 1) +
  geom_line(aes(colour = factor(id))) +
  scale_x_continuous(breaks = seq(0,2017,5))+
  theme_bw() +
  theme(axis.text.x = element_text(angle = 90, hjust = 1)) +
   labs(title="General vs Parasites",x='Year', y=expression(sqrt(italic('Article Number'))), fill="Subset",color = "Article Type\n") +
  scale_y_continuous(trans='sqrt') +

  # 1966: allozymes
  geom_vline(xintercept=1966,linetype="dashed", colour='grey') +
  geom_text(aes(x=1966, label="allozymes", y=35000), colour="grey", angle=90, vjust = -1) + 
  # 1983: discovery of the polymerase chain reaction (PCR) technique
  geom_vline(xintercept=1983,linetype="dashed", colour='grey') +
  geom_text(aes(x=1983, label="Polymerase chain reaction", y=35000), colour="grey", angle=90, vjust = -1) +
  # 1986: First automated DNA sequencer
  geom_vline(xintercept=1986,linetype="dashed", colour='grey') +
  geom_text(aes(x=1986, label="Automated DNA sequencer", y=35000), colour="grey", angle=90, vjust = -1) +  
  # 1990: WOS artifact
  geom_vline(xintercept=1990,linetype="dashed", colour='grey') +
  geom_text(aes(x=1990, label="***", y=35000), colour="grey", angle=90, vjust = -1) +    
  geom_vline(xintercept=2005,linetype="dashed", colour='grey') +
  geom_text(aes(x=2005, label="High throughput whole genome seq", y=35000), colour="grey", angle=90, vjust = -1)  

# Allozyme: Parasite vs medical parasite
dmerged %>% select(.,ArticlesP.allozyme,ArticlesP.med.allozyme,Year) %>% filter(.,Year > 1959 & Year!=2018 & Year!=2019) %>% tidyr::gather("id", "value", 1:2) %>% ggplot(aes(Year, value)) + 
 # geom_point(aes(colour = factor(id)),size = 1) +
  geom_line(aes(colour = factor(id))) +
  theme_bw() +
  scale_x_continuous(breaks = seq(0,2017,5))+
  theme(axis.text.x = element_text(angle = 90, hjust = 1)) +
  labs(title="Allozymes-Parasites",x='Year', y=expression(sqrt(italic('Article Number'))), fill="Subset",color = "Article Type\n") +
   scale_y_continuous(trans='sqrt')


#repeat the above steps for plots for genomic and nucleotide


###########code for word clouds and networks############

#cleaning up keywords
#this it to remove abreiviations and other issues in the dataset

#choose dataframe to run:
#test<-citations_df_genomics_P_nuc
#test<-citations_df_genomics_P_gen
test<-citations_df_genomics_P_alo


test<-test %>% mutate(DE = gsub('POLYMERASE CHAIN;REACTION',' POLYMERASE CHAIN REACTION',DE), 
                                                                     DE = gsub('NEXT-GENERATION;SEQUENCING',' NEXT-GENERATION SEQUENCING',DE),
                                                                     DE = gsub('PLASMODIUM;FALCIPARUM','PLASMODIUM FALCIPARUM',DE),
                                                                     DE = gsub('PLASMODIUM FALCIPARUM MALARIA','PLASMODIUM FALCIPARUM; MALARIA',DE),
                                                                     DE = gsub('RNA-SEQ',' RNASEQ',DE),
                                                                     DE = gsub('; TOXOPLASMA;','; TOXOPLASMA GONDI;',DE),
                                                                     DE = gsub('; CAENORHABDITIS;','; CAENORHABDITIS ELEGANS;',DE),
                                                                     DE = gsub('NEXT-GENERATION DNA SEQUENCING',' NEXT-GENERATION SEQUENCING',DE),
                                                                     DE = gsub('NEXT GENERATION;SEQUENCING',' NEXT-GENERATION SEQUENCING',DE),
                                                                     DE = gsub('NEXT GENERATION SEQUENCING',' NEXT-GENERATION SEQUENCING',DE),
                                                                     DE = gsub('DE;NOVO ASSEMBLY',' DE NOVO ASSEMBLY',DE),
                                                                     DE = gsub('HOST-PARASITE;INTERACTION',' HOST-PARASITE INTERACTION',DE),
                                                                     DE = gsub('HOST-PARASITE INTERACTIONS',' HOST-PARASITE INTERACTION',DE),
                                                                     DE = gsub('TRANSCRIPTOME',' TRANSCRIPTOMICS',DE),
                                                                     DE = gsub('GENE EXPRESSION PROFILING',' GENE EXPRESSION',DE),
                                                                     DE = gsub('GENE EXPRESSION PROFILE',' GENE EXPRESSION',DE),
                                                                     DE = gsub('GENE;EXPRESSION',' GENE EXPRESSION',DE),
                                                                     DE = gsub('GENE;REGULATION',' GENE REGULATION',DE),
                                                                     DE = gsub('IMMUNE;RESPONSE',' IMMUNE RESPONSE',DE),
                                                                     DE = gsub('CRYPTIC;SPECIES',' CRYPTIC SPECIES',DE),
                                                                     DE = gsub('POPULATION;STRUCTURE',' POPULATION STRUCTURE',DE),
                                                                     DE = gsub('ALLOZYMES','ALLOZYME',DE),
                                                                     DE = gsub('ISOENZYMES','ISOENZYME',DE),
                                                                     DE = gsub('ISOZYME','ISOENZYME',DE),
                                                                     DE = gsub('ISOZYMES','ISOENZYME',DE),
                                                                     DE = gsub("CHAGAS' DISEASE",'CHAGAS DISEASE',DE),
                                                                     DE = gsub("CHAGAS;DISEASE",'CHAGAS DISEASE',DE),
                                                                     DE = gsub("GENETIC;VARIATION",'GENETIC VARIATION',DE),
                                                                     DE = gsub("ZYMODEMES",'ZYMODEME',DE),
                                                                     DE = gsub("ENTAMOEBA-HISTOLYTICA",'ENTAMOEBA HISTOLYTICA',DE),
                                                                     DE = gsub("TRYPANOSOMA-CRUZI",'TRYPANOSOMA CRUZI',DE),
                                                                     DE = gsub("MULTILOCUS ENZYME ELECTROPHORESIS",'MULTILOCUS; ENZYME; ELECTROPHORESIS',DE),
                                                                     DE = gsub('ISOENZYME ELECTROPHORESIS','ISOENZYME; ELECTROPHORESIS',DE),
                                                                     DE = gsub('ISOENZYMES ELECTROPHORESIS','ISOENZYME; ELECTROPHORESIS',DE),
                                                                     DE = gsub('SOLOMON;ISLANDS','SOLOMON ISLANDS',DE),
                                                                     DE = gsub('ALLOZYMES ELECTROPHORESIS','ALLOZYME; ELECTROPHORESIS',DE),
                                                                     DE = gsub('ALLOZYME ELECTROPHORESIS','ALLOZYME; ELECTROPHORESIS',DE),
                                                                     DE = gsub('SAND FLIES','SANDFLIES',DE),
                                                                     DE = gsub('ISOENZYMES','ISOENZYME',DE),
                                                                     DE = gsub('POLYMERASE-CHAIN-REACTION',' POLYMERASE CHAIN REACTION',DE),
                                                                     DE = gsub('POLYMERASE CHAIN-REACTION',' POLYMERASE CHAIN REACTION',DE),
                                                                     DE = gsub('PCR',' POLYMERASE CHAIN REACTION',DE),
                                                                     DE = gsub('POLYMERASE;CHAIN REACTION',' POLYMERASE CHAIN REACTION',DE),
                                                                     DE = gsub('DOGS',' DOG',DE),
                                                                     DE = gsub('P. FALCIPARUM',' PLASMODIUM FALCIPARUM',DE),
                                                                     DE = gsub('; 18S;','; 18S RRNA;',DE),
                                                                     DE = gsub('; 18S$','; 18S RRNA',DE),
                                                                     DE = gsub('; TOXOPLASMA; GONDI;','; TOXOPLASMA GONDI;',DE),
                                                                     DE = gsub('; TOXOPLASMA; GONDI$','; TOXOPLASMA GONDI',DE),
                                                                     DE = gsub('RDNA','RRNA',DE),
                                                                     DE = gsub('NEW;SPECIES',' NEW SPECIES',DE),
                                                                     DE = gsub('; GENE; EXPRESSION;','; GENE EXPRESSION;',DE),
                                                                     DE = gsub('; GENE;EXPRESSION$','; GENE EXPRESSION',DE),
                                                                     DE = gsub('TICKS',' TICK',DE),
                                                                     DE = gsub('PHYLOGENETICS',' PHYLOGENETIC',DE),
                                                                     DE = gsub('; PHYLOGENETIC;ANALYSIS;','; PHYLOGENETIC ANALYSIS;',DE),
                                                                     DE = gsub('; PHYLOGENETIC;ANALYSIS$','; PHYLOGENETIC ANALYSIS',DE),
                                                                     DE = gsub('; GENETIC;DIVERSITY;','; GENETIC DIVERSITY;',DE),
                                                                     DE = gsub('; GENETIC;DIVERSITY$','; GENETIC DIVERSITY',DE),
                                                                     DE = gsub('; POPULATION;GENETICS;','; POPULATION GENETICS;',DE),
                                                                     DE = gsub('; POPULATION;GENETICS$','; POPULATION GENETICS',DE)) 

#############wordclouds############

#summarising top 200 keywords into a dataframe
test_ana <- biblioAnalysis(test, sep = ";")
test_ana.sum <- summary(object = test_ana, k = 200, pause = FALSE)
forwordcloud<-as.data.frame(cbind(as.character(trimws(test_ana.sum$MostRelKeywords$`Author Keywords (DE)     `, which = c("both", "left", "right"))),test_ana.sum$MostRelKeywords[2]),stringsAsFactors=FALSE)
colnames(forwordcloud)<-c('keyword','count_papers')

#we want to drop the keywords we searched for from our dataframe and molecular markers
#allozyme
forwordcloud<- forwordcloud %>% filter(!grepl('ALLOZYMES|TRYPANOSOMA CRUZI|ISOENZYMES|ELECTROPHORESIS|ISOENZYME|CARBONIC ANHYDRASE|LEISHMANIA|LEISHMANIA INFANTUM|CHAGAS DISEASE|ISOZYME|LEISHMANIASIS|ISOENZYME ELECTROPHORESIS|ISOZYMES|ZYMODEME|ALLOZYME|ALLOZYME ELECTROPHORESIS|TRYPANOSOMA-CRUZI|ZYMODEMES|BRAZIL|ENTAMOEBA HISTOLYTICA|MALARIA|PARASITE|PROTOZOA|SULFONAMIDE|VISCERAL LEISHMANIASIS|CUTANEOUS LEISHMANIASIS|GENETIC|GENETICS|LEISHMANIA TROPICA|METALLOENZYMES|MULTILOCUS ENZYME ELECTROPHORESIS|NEMATODE|COLOMBIA|ENTAMOEBA DISPAR|ISOENZYME ANALYSIS|LEISHMANIA DONOVANI|TRYPANOSOMA BRUCEI|BOLIVIA|ENTAMOEBA-HISTOLYTICA|GLUTATHIONE|GLUTATHIONE S-TRANSFERASE|ISOZYME ELECTROPHORESIS|KINETOPLAST DNA|LUTZOMYIA LONGIPALPIS|MOROCCO|PLASMODIUM FALCIPARUM|PURIFICATION|TRIATOMA INFESTANS|VECTOR|ALLOZYME VARIATION|CESTODA|CHAGAS|CLONALITY|CLONES|DOG|ECUADOR|ETHIOPIA|FRANCE|GENETIC MARKERS|HYMENOPTERA|KARYOTYPE|MITOCHONDRIAL DNA|MULTILOCUS ENZYME|PARASITISM|RAPD|SCHISTOSOMA|SCHISTOSOMA MANSONI|SHEEP|SPAIN|STRAIN|TRYPANOSOMA-BRUCEI|ACETYLCHOLINESTERASE|ALLOZYME MARKERS|AMEBIASIS|ANALYSIS|ANOPHELES DIRUS|ANOPHELES FARAUTI|CLONAL STRUCTURE|CLONE|DOGS|ECHINOCOCCUS GRANULOSUS|ETHYL N-ISOPROPYL OXAMATE|F-ST|FISH|GASTROPODA|GIARDIA|HYDRATASE ACTIVITY|INDIA|LECITHOCHIRIUM|LEISHMANIA BRAZILIENSIS|LICE|MALATE DEHYDROGENASE|MEXICO|MICROSPORIDIA|OPISTHORCHIS VIVERRINI|PARASITES|PARASITIC PLANTS|PHLEBOTOMUS PERNICIOSUS|PROTEIN|RANDOMLY AMPLIFIED POLYMORPHIC DNA|SCHISTOSOMA-MANSONI|STRAINS|SULFAMATE|SUPEROXIDE DISMUTASE|TOXOPLASMA GONDII|TRICHINELLA|TRICHINELLA SPIRALIS|TRYPANOSOMA BRUCEI GAMBIENSE|TRYPANOSOMA RANGELI|VENEZUELA|ACARI|AIDS|AMAZON|AMERICAN TEGUMENTARY LEISHMANIASIS|AMOEBIASIS|AMOVA|ANISAKIS BREVISPICULATA|ANOPHELES|ANOPHELES MINIMUS|ANOPHELES NUNEZTOVARI|ANOPHELES RANGELI|ANTARCTIC CARBONIC ANHYDRASE|ASCARIS SUUM|BACTERIA|BETA-CA-CLASS ENZYME',keyword,ignore.case = TRUE))

wholewords<-forwordcloud %>% group_by(.,keyword) %>% summarise(count_papers = sum(as.numeric(count_papers)))
wordcloud(tolower(wholewords$keyword),as.numeric(wholewords$count_papers), ,max.words=20,color=alpha("#F652CC", seq(0.4,1, 0.05)),random.order=FALSE,scale=c(1.2,.6))

#repeat the above steps for plots for genomic and nucleotide
# nucleotide
forwordcloud<- forwordcloud %>% filter(!grepl('MALARIA|PCR|PLASMODIUM FALCIPARUM|TOXOPLASMA GONDII|TRYPANOSOMA CRUZI|PLASMODIUM|LEISHMANIA|PARASITE|POLYMERASE CHAIN REACTION|TICKS|PLASMODIUM VIVAX|REAL-TIME PCR|DOG|MOLECULAR|TICK|MICROSATELLITES|CHAGAS DISEASE|LEISHMANIASIS|IRAN|CATTLE|NEMATODE|MICROSPORIDIA|DOGS|SCHISTOSOMA MANSONI|LEISHMANIA INFANTUM|BRAZIL|RICKETTSIA|CRYPTOSPORIDIUM|PCR-RFLP|IXODES RICINUS|DNA|SHEEP|ELISA|VISCERAL LEISHMANIASIS|GENE|ANAPLASMA PHAGOCYTOPHILUM|NEOSPORA CANINUM|TOXOPLASMOSIS|MICROSATELLITE|TRYPANOSOMA BRUCEI|MITOCHONDRIAL DNA|PARASITES|ENTAMOEBA HISTOLYTICA|CUTANEOUS LEISHMANIASIS|APICOMPLEXA|ECHINOCOCCUS GRANULOSUS|PROTOZOA|BABESIA|MOSQUITO|CHINA|SCHISTOSOMA JAPONICUM|BORRELIA BURGDORFERI|RT-PCR|PROTEIN|ANOPHELES|CYTOKINES|MICROARRAY|TRYPANOSOMA|ANOPHELES GAMBIAE|RDNA|WOLBACHIA|RIBOSOMAL DNA|SEQUENCING|ANAPLASMA|LYME DISEASE|LEISHMANIA MAJOR|SCHISTOSOMIASIS|GIARDIA|ITS|TOXOPLASMA|BORRELIA|MYXOZOA|QPCR|COI|VECTOR|THEILERIA|HUMAN|ANALYSIS|18S RDNA|GENETIC|MITOCHONDRIAL GENOME|PARASITISM|FASCIOLA HEPATICA|SEQUENCE|GENETICS|ITS2|LEISHMANIA DONOVANI|IXODES|EHRLICHIA|CAT|TURKEY|MTDNA|INDIA|CRYPTOSPORIDIUM PARVUM|AFRICA|18S RRNA|GIARDIA DUODENALIS|NESTED PCR|EHRLICHIA CANIS|HAEMONCHUS CONTORTUS|REACTION|RODENTS|MITOCHONDRIA|POLYMERASE CHAIN|ENTEROCYTOZOON BIENEUSI|BARTONELLA|CLONING|HIV|COX1|CYTOKINE|NEMATODES|THAILAND|BACTERIA|COLOMBIA|GENOME|MULTIPLEX PCR|ECHINOCOCCUS MULTILOCULARIS|FISH|LAMP|CHLOROQUINE|CANINE|FALCIPARUM|CHILDREN|CYTOCHROME B|ITS1|RFLP|BABESIA BOVIS|CDNA|FILARIASIS|ITALY|INTERNAL TRANSCRIBED SPACER|AVIAN MALARIA',keyword,ignore.case = TRUE))

# genomics
forwordcloud<- forwordcloud %>% filter(!grepl('MALARIA|GENOMICS|TRANSCRIPTOME|PLASMODIUM FALCIPARUM|PCR|GENOME|RNA-SEQ|TRANSCRIPTOMICS|PARASITE|PLASMODIUM|LEISHMANIA|TRYPANOSOMA CRUZI|NEMATODE|TOXOPLASMA GONDII|PROTEOMICS|GENE|APICOMPLEXA|POLYMERASE CHAIN REACTION|MOSQUITO|SCHISTOSOMA MANSONI|DNA|SEQUENCING|PLASMODIUM VIVAX|MICROARRAY|MICROSPORIDIA|RNAI|TICK|TRYPANOSOMA BRUCEI|ANOPHELES GAMBIAE|NEXT-GENERATION SEQUENCING|METAGENOMICS|MICROSATELLITES|PROTOZOA|GENETICS|WOLBACHIA|MITOCHONDRIAL GENOME|PARASITES|CAENORHABDITIS ELEGANS|RNA INTERFERENCE|TRANSCRIPTION|PARASITISM|TICKS|CATTLE|TRYPANOSOMA|ANOPHELES|SCHISTOSOMIASIS|GENETIC|HAEMONCHUS CONTORTUS|MICROSATELLITE|NEMATODES|PROTEIN|ENTAMOEBA HISTOLYTICA|SCHISTOSOMA|TRANSPOSABLE ELEMENTS|ECHINOCOCCUS GRANULOSUS|CHAGAS DISEASE|REAL-TIME PCR|LEISHMANIASIS|CRYPTOSPORIDIUM|LEISHMANIA MAJOR|MITOCHONDRIA|SCHISTOSOMA JAPONICUM|SHEEP|ANALYSIS|BACTERIA|CLONING|MICRORNA|IRAN|MASS SPECTROMETRY|VECTOR|RNA|TOXOPLASMA|CDNA|CHROMOSOME|COMPARATIVE|IXODES RICINUS|VIRUS|HELMINTH|LEISHMANIA INFANTUM|THEILERIA|TRYPANOSOME|GIARDIA|PROMOTER|RNA EDITING|SCHISTOSOME|GENES|NEOSPORA CANINUM|RIBOSOMAL DNA|SEQUENCE|SNP|TRANSPOSON|FISH|GENE REGULATION|GENOME SEQUENCING|METABARCODING|PROTIST|RICKETTSIA|TRYPANOSOMATIDS|CLONORCHIS SINENSIS|CRYPTOSPORIDIUM PARVUM|DROSOPHILA|FUNGI|INSECT|MULTIGENE FAMILY|PCR-RFLP|ROOT-KNOT NEMATODE|ALTERNATIVE SPLICING|ANTHELMINTIC RESISTANCE|ASPERGILLUS FLAVUS|BORRELIA BURGDORFERI|BRUGIA MALAYI|CONTROL|DNA METHYLATION|EIMERIA|ENTAMOEBA|EST|GENOMIC|GENOMIC DNA|HYMENOPTERA|REACTION',keyword,ignore.case = TRUE))

#colours for word cloud
#allozyme #F652CC
#nucleotide #01EB4A
#genomic #619CFF


############networks############

library(stringr)        
library(tidytext)       
library(igraph)
library(ggraph)
library(widyr)

#clean keywords
test.keyword<-data_frame(id = test$UT,keyword2 = test$DE)  %>% mutate(keyword = strsplit(as.character(keyword2), ";")) %>% unnest(keyword) %>% select (-keyword2)
test.keyword<-test.keyword[!is.na(test.keyword$keyword),]
test.keyword<-test.keyword[-which(test.keyword$keyword == ""), ]
test.keyword$keyword<-trimws(test.keyword$keyword)

#count pairs
keyword_pairs <- test.keyword %>% pairwise_count(keyword, id, sort = TRUE, upper = FALSE)

#draw graph
keyword_pairs %>% arrange(., desc(n)) %>% filter(.,n>3) %>% 
  top_n(.,50,n) %>%
  graph_from_data_frame() %>%
  ggraph(layout = "fr") +
  geom_edge_link(aes(edge_alpha = n, edge_width = n), edge_colour = "#619CFF") +
  geom_node_point(size = 5) +
  geom_node_text(aes(label = name), repel = TRUE, point.padding = unit(0.2, "lines"),size=5) +
  theme_void()

##########sankey plot###############

#this is somewhat messy but works
library(plotly)
library(tm)
library(networkD3)
library(tidyverse)
library(tm)
library(RColorBrewer)


citations_df_genomics_P_nuc$era<- 'nucleotide' 
citations_df_genomics_P_gen$era<- 'genomic'
citations_df_genomics_P_alo$era<- 'allozyme'

test<-rbind(citations_df_genomics_P_nuc,citations_df_genomics_P_gen,citations_df_genomics_P_alo)
test<-bind_rows(citations_df_genomics_P_nuc,citations_df_genomics_P_gen,citations_df_genomics_P_alo)

#this is to classify the species into various groups 

testa<-test %>% mutate(protozoa=ifelse(grepl('protozoa|metamonada|apicomplexa|euglenozoa|amoebozoa|giardia|cryptosporidium|toxoplasm.*|haemosporidi.*|plasmodium|malaria.*|trypanosoma|trypanosom.*?[[:blank:]]+cruzi|chagas|trypanosom.*?[[:blank:]]+brucei.*|sleeping[[:blank:]]+sickness|sleep[[:blank:]]+fever|african[[:blank:]]+trypanosomiasis|leishmania.*|entamoeba', DE,ignore.case=T)|grepl('protozoa|metamonada|apicomplexa|euglenozoa|amoebozoa|giardia|cryptosporidium|toxoplasm.*|haemosporidi.*|plasmodium|malaria.*|trypanosoma|trypanosom.*?[[:blank:]]+cruzi|chagas|trypanosom.*?[[:blank:]]+brucei.*|sleeping[[:blank:]]+sickness|sleep[[:blank:]]+fever|african[[:blank:]]+trypanosomiasis|leishmania.*|entamoeba', ID,ignore.case=T)|grepl('protozoa|metamonada|apicomplexa|euglenozoa|amoebozoa|giardia|cryptosporidium|toxoplasm.*|haemosporidi.*|plasmodium|malaria.*|trypanosoma|trypanosom.*?[[:blank:]]+cruzi|chagas|trypanosom.*?[[:blank:]]+brucei.*|sleeping[[:blank:]]+sickness|sleep[[:blank:]]+fever|african[[:blank:]]+trypanosomiasis|leishmania.*|entamoeba', TI,ignore.case=T)|grepl('protozoa|metamonada|apicomplexa|euglenozoa|amoebozoa|giardia|cryptosporidium|toxoplasm.*|haemosporidi.*|plasmodium|malaria.*|trypanosoma|trypanosom.*?[[:blank:]]+cruzi|chagas|trypanosom.*?[[:blank:]]+brucei.*|sleeping[[:blank:]]+sickness|sleep[[:blank:]]+fever|african[[:blank:]]+trypanosomiasis|leishmania.*|entamoeba', SO,ignore.case=T)|grepl('protozoa|metamonada|apicomplexa|euglenozoa|amoebozoa|giardia|cryptosporidium|toxoplasm.*|haemosporidi.*|plasmodium|malaria.*|trypanosoma|trypanosom.*?[[:blank:]]+cruzi|chagas|trypanosom.*?[[:blank:]]+brucei.*|sleeping[[:blank:]]+sickness|sleep[[:blank:]]+fever|african[[:blank:]]+trypanosomiasis|leishmania.*|entamoeba', AB,ignore.case=T),'Protozoa',NA)) %>% 
  mutate(helminths=ifelse(grepl('helminths|trematod.*|digenean.*|fluke|monogenean.*|cestod.*|tapeworm|nematod.*|roundworm|acanthoceph.*|schistosomias.*|schistosoma.*|bilharzia|fasciol.*|echinococcosis|hydatidosis|echinococcus[[:blank:]]+granulosus|cysticercosis|taenia|dracuncul.*|guinea[[:blank:]]+worm|trichuri.*|whipworm|ascaris.*|ascariasis.*|hookworm|ancylostoma[[:blank:]]+duodenale|necator[[:blank:]]+americanus|onchocerc.*|onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness|lymphatic[[:blank:]]+filariasis|wuchereria.*|brugia[[:blank:]]+malayi|brugia[[:blank:]]+timori|trichinella', DE,ignore.case=T)|grepl('helminths|trematod.*|digenean.*|fluke|monogenean.*|cestod.*|tapeworm|nematod.*|roundworm|acanthoceph.*|schistosomias.*|schistosoma.*|bilharzia|fasciol.*|echinococcosis|hydatidosis|echinococcus[[:blank:]]+granulosus|cysticercosis|taenia|dracuncul.*|guinea[[:blank:]]+worm|trichuri.*|whipworm|ascaris.*|ascariasis.*|hookworm|ancylostoma[[:blank:]]+duodenale|necator[[:blank:]]+americanus|onchocerc.*|onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness|lymphatic[[:blank:]]+filariasis|wuchereria.*|brugia[[:blank:]]+malayi|brugia[[:blank:]]+timori|trichinella', ID,ignore.case=T)|grepl('helminths|trematod.*|digenean.*|fluke|monogenean.*|cestod.*|tapeworm|nematod.*|roundworm|acanthoceph.*|schistosomias.*|schistosoma.*|bilharzia|fasciol.*|echinococcosis|hydatidosis|echinococcus[[:blank:]]+granulosus|cysticercosis|taenia|dracuncul.*|guinea[[:blank:]]+worm|trichuri.*|whipworm|ascaris.*|ascariasis.*|hookworm|ancylostoma[[:blank:]]+duodenale|necator[[:blank:]]+americanus|onchocerc.*|onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness|lymphatic[[:blank:]]+filariasis|wuchereria.*|brugia[[:blank:]]+malayi|brugia[[:blank:]]+timori|trichinella', TI,ignore.case=T)|grepl('helminths|trematod.*|digenean.*|fluke|monogenean.*|cestod.*|tapeworm|nematod.*|roundworm|acanthoceph.*|schistosomias.*|schistosoma.*|bilharzia|fasciol.*|echinococcosis|hydatidosis|echinococcus[[:blank:]]+granulosus|cysticercosis|taenia|dracuncul.*|guinea[[:blank:]]+worm|trichuri.*|whipworm|ascaris.*|ascariasis.*|hookworm|ancylostoma[[:blank:]]+duodenale|necator[[:blank:]]+americanus|onchocerc.*|onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness|lymphatic[[:blank:]]+filariasis|wuchereria.*|brugia[[:blank:]]+malayi|brugia[[:blank:]]+timori|trichinella', SO,ignore.case=T)|grepl('helminths|trematod.*|digenean.*|fluke|monogenean.*|cestod.*|tapeworm|nematod.*|roundworm|acanthoceph.*|schistosomias.*|schistosoma.*|bilharzia|fasciol.*|echinococcosis|hydatidosis|echinococcus[[:blank:]]+granulosus|cysticercosis|taenia|dracuncul.*|guinea[[:blank:]]+worm|trichuri.*|whipworm|ascaris.*|ascariasis.*|hookworm|ancylostoma[[:blank:]]+duodenale|necator[[:blank:]]+americanus|onchocerc.*|onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness|lymphatic[[:blank:]]+filariasis|wuchereria.*|brugia[[:blank:]]+malayi|brugia[[:blank:]]+timori|trichinella', AB,ignore.case=T),'Helminths',NA)) %>% 
  
  mutate(arthropod=ifelse(grepl('arthropod.*|insecta|arachnida|crustacea|[[:blank:]]+wasp.*?[[:blank:]]+|[[:blank:]]+fly[[:blank:]]+|[[:blank:]]+flies[[:blank:]]+|tick.*|lice|louse|flea.*|pentastomida|^wasp.*?[[:blank:]]+|[[:blank:]]+wasp\\.|[[:blank:]]+wasps\\.|^fly[[:blank:]]+|[[:blank:]]+fly\\.|^flies[[:blank:]]+|[[:blank:]]+flies\\.', DE,ignore.case=T)|grepl('arthropod.*|insecta|arachnida|crustacea|[[:blank:]]+wasp.*?[[:blank:]]+|[[:blank:]]+fly[[:blank:]]+|[[:blank:]]+flies[[:blank:]]+|tick.*|lice|louse|flea.*|pentastomida|^wasp.*?[[:blank:]]+|[[:blank:]]+wasp\\.|[[:blank:]]+wasps\\.|^fly[[:blank:]]+|[[:blank:]]+fly\\.|^flies[[:blank:]]+|[[:blank:]]+flies\\.', ID,ignore.case=T)|grepl('arthropod.*|insecta|arachnida|crustacea|[[:blank:]]+wasp.*?[[:blank:]]+|[[:blank:]]+fly[[:blank:]]+|[[:blank:]]+flies[[:blank:]]+|tick.*|lice|louse|flea.*|pentastomida|^wasp.*?[[:blank:]]+|[[:blank:]]+wasp\\.|[[:blank:]]+wasps\\.|^fly[[:blank:]]+|[[:blank:]]+fly\\.|^flies[[:blank:]]+|[[:blank:]]+flies\\.', TI,ignore.case=T)|grepl('arthropod.*|insecta|arachnida|crustacea|[[:blank:]]+wasp.*?[[:blank:]]+|[[:blank:]]+fly[[:blank:]]+|[[:blank:]]+flies[[:blank:]]+|tick.*|lice|louse|flea.*|pentastomida|^wasp.*?[[:blank:]]+|[[:blank:]]+wasp\\.|[[:blank:]]+wasps\\.|^fly[[:blank:]]+|[[:blank:]]+fly\\.|^flies[[:blank:]]+|[[:blank:]]+flies\\.', SO,ignore.case=T)|grepl('arthropod.*|insecta|arachnida|crustacea|[[:blank:]]+wasp.*?[[:blank:]]+|[[:blank:]]+fly[[:blank:]]+|[[:blank:]]+flies[[:blank:]]+|tick.*|lice|louse|flea.*|pentastomida|^wasp.*?[[:blank:]]+|[[:blank:]]+wasp\\.|[[:blank:]]+wasps\\.|^fly[[:blank:]]+|[[:blank:]]+fly\\.|^flies[[:blank:]]+|[[:blank:]]+flies\\.', AB,ignore.case=T),'Arthropod',NA)) %>% 
  
  mutate(other=ifelse(grepl('mesozoa|myxozoa|microsporid.*|fungi|fungus', ID,ignore.case=T)|grepl('mesozoa|myxozoa|microsporid.*|fungi|fungus', TI,ignore.case=T)|grepl('mesozoa|myxozoa|microsporid.*|fungi|fungus', SO,ignore.case=T)|grepl('mesozoa|myxozoa|microsporid.*|fungi|fungus', AB,ignore.case=T),'Other',NA)) %>% 
  
  mutate(arthropod=ifelse(protozoa=='NA' & helminths=='NA' & arthropod=='NA' & other=='NA' & grepl('insect.*', DE,ignore.case=T)|protozoa=='NA' & helminths=='NA' & arthropod=='NA' & other=='NA' & grepl('insect.*', ID,ignore.case=T)|protozoa=='NA' & helminths=='NA' & arthropod=='NA' & other=='NA' & grepl('insect.*', TI,ignore.case=T)|grepl('insect.*', SO,ignore.case=T)|protozoa=='NA' & helminths=='NA' & arthropod=='NA' & other=='NA' & grepl('insect.*', AB,ignore.case=T),'Arthropod',arthropod)) %>%
  
  mutate(metamonada=ifelse(grepl('metamonada|giardia', ID,ignore.case=T)|grepl('metamonada|giardia', TI,ignore.case=T)|grepl('metamonada|giardia', SO,ignore.case=T)|grepl('metamonada|giardia', AB,ignore.case=T),'Metamonada',NA)) %>% 
  
  mutate(giardia=ifelse(grepl('giardia', ID,ignore.case=T)|grepl('giardia', TI,ignore.case=T)|grepl('giardia', SO,ignore.case=T)|grepl('giardia', AB,ignore.case=T),'Giardia',NA)) %>% 
  
  mutate(apicomplexa=ifelse(grepl('apicomplexa|cryptosporidium|toxoplasm.*|haemosporidi.*|plasmodium|malaria.*', ID,ignore.case=T)|grepl('apicomplexa|cryptosporidium|toxoplasm.*|haemosporidi.*|plasmodium|malaria.*', TI,ignore.case=T)|grepl('apicomplexa|cryptosporidium|toxoplasm.*|haemosporidi.*|plasmodium|malaria.*', SO,ignore.case=T)|grepl('apicomplexa|cryptosporidium|toxoplasm.*|haemosporidi.*|plasmodium|malaria.*', AB,ignore.case=T),'Apicomplexa',NA)) %>% 
  
  mutate(cryptosporidium=ifelse(grepl('cryptosporidium', ID,ignore.case=T)|grepl('cryptosporidium', TI,ignore.case=T)|grepl('cryptosporidium', SO,ignore.case=T)|grepl('cryptosporidium', AB,ignore.case=T),'Cryptosporidium',NA)) %>% 
  
  mutate(toxoplasm=ifelse(grepl('toxoplasm.*', ID,ignore.case=T)|grepl('toxoplasm.*', TI,ignore.case=T)|grepl('toxoplasm.*', SO,ignore.case=T)|grepl('toxoplasm.*', AB,ignore.case=T),'Toxoplasm',NA)) %>% 
  
  mutate(haemosporidi=ifelse(grepl('haemosporidi.*', ID,ignore.case=T)|grepl('haemosporidi.*', TI,ignore.case=T)|grepl('haemosporidi.*', SO,ignore.case=T)|grepl('haemosporidi.*', AB,ignore.case=T),'Haemosporidi',NA)) %>% 
  
  mutate(plasmodium_malaria=ifelse(grepl('plasmodium|malaria.*', ID,ignore.case=T)|grepl('plasmodium|malaria.*', TI,ignore.case=T)|grepl('plasmodium|malaria.*', SO,ignore.case=T)|grepl('plasmodium|malaria.*', AB,ignore.case=T),'Plasmodium_malaria',NA)) %>% 
  
  mutate(euglenozoa=ifelse(grepl('euglenozoa|trypanosoma|trypanosom.*[[:blank:]]+cruzi|chagas|trypanosom.*[[:blank:]]+brucei.*|sleeping[[:blank:]]+sickness|sleep[[:blank:]]+fever|african[[:blank:]]+trypanosomiasis|leishmania.*', ID,ignore.case=T)|grepl('euglenozoa|trypanosoma|trypanosom.*[[:blank:]]+cruzi|chagas|trypanosom.*[[:blank:]]+brucei.*|sleeping[[:blank:]]+sickness|sleep[[:blank:]]+fever|african[[:blank:]]+trypanosomiasis|leishmania.*', TI,ignore.case=T)|grepl('euglenozoa|trypanosoma|trypanosom.*[[:blank:]]+cruzi|chagas|trypanosom.*[[:blank:]]+brucei.*|sleeping[[:blank:]]+sickness|sleep[[:blank:]]+fever|african[[:blank:]]+trypanosomiasis|leishmania.*', SO,ignore.case=T)|grepl('euglenozoa|trypanosoma|trypanosom.*[[:blank:]]+cruzi|chagas|trypanosom.*[[:blank:]]+brucei.*|sleeping[[:blank:]]+sickness|sleep[[:blank:]]+fever|african[[:blank:]]+trypanosomiasis|leishmania.*', AB,ignore.case=T),'Euglenozoa',NA)) %>% 
  
  mutate(trypanosoma=ifelse(grepl('trypanosoma|trypanosom.*[[:blank:]]+cruzi|chagas|trypanosom.*[[:blank:]]+brucei.*|sleeping[[:blank:]]+sickness|sleep[[:blank:]]+fever|african[[:blank:]]+trypanosomiasis', ID,ignore.case=T)|grepl('trypanosoma|trypanosom.*[[:blank:]]+cruzi|chagas|trypanosom.*[[:blank:]]+brucei.*|sleeping[[:blank:]]+sickness|sleep[[:blank:]]+fever|african[[:blank:]]+trypanosomiasis', TI,ignore.case=T)|grepl('trypanosoma|trypanosom.*[[:blank:]]+cruzi|chagas|trypanosom.*[[:blank:]]+brucei.*|sleeping[[:blank:]]+sickness|sleep[[:blank:]]+fever|african[[:blank:]]+trypanosomiasis', SO,ignore.case=T)|grepl('trypanosoma|trypanosom.*[[:blank:]]+cruzi|chagas|trypanosom.*[[:blank:]]+brucei.*|sleeping[[:blank:]]+sickness|sleep[[:blank:]]+fever|african[[:blank:]]+trypanosomiasis', AB,ignore.case=T),'Trypanosoma',NA)) %>% 
  
  mutate(leishmania=ifelse(grepl('leishmania.*', ID,ignore.case=T)|grepl('leishmania.*', TI,ignore.case=T)|grepl('leishmania.*', SO,ignore.case=T)|grepl('leishmania.*', AB,ignore.case=T),'Leishmania',NA)) %>% 
  
  mutate(amoebozoa=ifelse(grepl('amoebozoa|entamoeba', ID,ignore.case=T)|grepl('amoebozoa|entamoeba', TI,ignore.case=T)|grepl('amoebozoa|entamoeba', SO,ignore.case=T)|grepl('amoebozoa|entamoeba', AB,ignore.case=T),'Amoebozoa',NA)) %>% 
  
  mutate(entamoeba=ifelse(grepl('entamoeba', ID,ignore.case=T)|grepl('entamoeba', TI,ignore.case=T)|grepl('entamoeba', SO,ignore.case=T)|grepl('entamoeba', AB,ignore.case=T),'Entamoeba',NA)) %>% 
  
  mutate(trematode=ifelse(grepl('trematod.*|digenean.*|fluke|schistosomias.*|schistosoma.*|bilharzia|fasciol.*', TI,ignore.case=T)|grepl('trematod.*|digenean.*|fluke|schistosomias.*|schistosoma.*|bilharzia|fasciol.*', ID,ignore.case=T)|grepl('trematod.*|digenean.*|fluke|schistosomias.*|schistosoma.*|bilharzia|fasciol.*', TI,ignore.case=T)|grepl('trematod.*|digenean.*|fluke|schistosomias.*|schistosoma.*|bilharzia|fasciol.*', SO,ignore.case=T)|grepl('trematod.*|digenean.*|fluke|schistosomias.*|schistosoma.*|bilharzia|fasciol.*', AB,ignore.case=T),'Trematode',NA)) %>% 
  
  mutate(schistosoma=ifelse(grepl('schistosomias.*|schistosoma.*|bilharzia', ID,ignore.case=T)|grepl('schistosomias.*|schistosoma.*|bilharzia', TI,ignore.case=T)|grepl('schistosomias.*|schistosoma.*|bilharzia', SO,ignore.case=T)|grepl('schistosomias.*|schistosoma.*|bilharzia', AB,ignore.case=T),'Schistosoma',NA)) %>% 
  
  mutate(fasciol=ifelse(grepl('fasciol.*', ID,ignore.case=T)|grepl('fasciol.*', TI,ignore.case=T)|grepl('fasciol.*', SO,ignore.case=T)|grepl('fasciol.*', AB,ignore.case=T),'Fasciol',NA)) %>% 
  
  mutate(monogenean=ifelse(grepl('monogenean.*', ID,ignore.case=T)|grepl('monogenean.*', TI,ignore.case=T)|grepl('monogenean.*', SO,ignore.case=T)|grepl('monogenean.*', AB,ignore.case=T),'Monogenean',NA)) %>% 
  
  mutate(cestode=ifelse(grepl('cestod.*|tapeworm|echinococcosis|hydatidosis|echinococcus[[:blank:]]+granulosus|cysticercosis|taenia', ID,ignore.case=T)|grepl('cestod.*|tapeworm|echinococcosis|hydatidosis|echinococcus[[:blank:]]+granulosus|cysticercosis|taenia', TI,ignore.case=T)|grepl('cestod.*|tapeworm|echinococcosis|hydatidosis|echinococcus[[:blank:]]+granulosus|cysticercosis|taenia', SO,ignore.case=T)|grepl('cestod.*|tapeworm|echinococcosis|hydatidosis|echinococcus[[:blank:]]+granulosus|cysticercosis|taenia', AB,ignore.case=T),'Cestode',NA)) %>% 
  
  mutate(echinococcus=ifelse(grepl('echinococcosis|hydatidosis|echinococcus[[:blank:]]+granulosus', ID,ignore.case=T)|grepl('echinococcosis|hydatidosis|echinococcus[[:blank:]]+granulosus', TI,ignore.case=T)|grepl('echinococcosis|hydatidosis|echinococcus[[:blank:]]+granulosus', SO,ignore.case=T)|grepl('echinococcosis|hydatidosis|echinococcus[[:blank:]]+granulosus', AB,ignore.case=T),'Echinococcus',NA)) %>% 
  
  mutate(Cysticerosis=ifelse(grepl('cysticercosis|taenia', ID,ignore.case=T)|grepl('cysticercosis|taenia', TI,ignore.case=T)|grepl('cysticercosis|taenia', SO,ignore.case=T)|grepl('cysticercosis|taenia', AB,ignore.case=T),'Cysticercosis',NA)) %>% 
  
  mutate(nematode=ifelse(grepl('nematod.*|roundworm|dracuncul.*|guinea[[:blank:]]+worm|trichuri.*|whipworm|ascaris.*|ascariasis.*|hookworm|ancylostoma[[:blank:]]+duodenale|necator[[:blank:]]+americanus|onchocerc.*|onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness|lymphatic[[:blank:]]+filariasis|wuchereria.*|brugia[[:blank:]]+malayi|brugia[[:blank:]]+timori|trichinella', ID,ignore.case=T)|grepl('nematod.*|roundworm|dracuncul.*|guinea[[:blank:]]+worm|trichuri.*|whipworm|ascaris.*|ascariasis.*|hookworm|ancylostoma[[:blank:]]+duodenale|necator[[:blank:]]+americanus|onchocerc.*|onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness|lymphatic[[:blank:]]+filariasis|wuchereria.*|brugia[[:blank:]]+malayi|brugia[[:blank:]]+timori|trichinella', TI,ignore.case=T)|grepl('nematod.*|roundworm|dracuncul.*|guinea[[:blank:]]+worm|trichuri.*|whipworm|ascaris.*|ascariasis.*|hookworm|ancylostoma[[:blank:]]+duodenale|necator[[:blank:]]+americanus|onchocerc.*|onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness|lymphatic[[:blank:]]+filariasis|wuchereria.*|brugia[[:blank:]]+malayi|brugia[[:blank:]]+timori|trichinella', SO,ignore.case=T)|grepl('nematod.*|roundworm|dracuncul.*|guinea[[:blank:]]+worm|trichuri.*|whipworm|ascaris.*|ascariasis.*|hookworm|ancylostoma[[:blank:]]+duodenale|necator[[:blank:]]+americanus|onchocerc.*|onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness|lymphatic[[:blank:]]+filariasis|wuchereria.*|brugia[[:blank:]]+malayi|brugia[[:blank:]]+timori|trichinella', AB,ignore.case=T),'Nematode',NA)) %>% 
  
  mutate(guineaworm=ifelse(grepl('dracuncul.*|guinea[[:blank:]]+worm', ID,ignore.case=T)|grepl('dracuncul.*|guinea[[:blank:]]+worm', TI,ignore.case=T)|grepl('dracuncul.*|guinea[[:blank:]]+worm', SO,ignore.case=T)|grepl('dracuncul.*|guinea[[:blank:]]+worm', AB,ignore.case=T),'Guineaworm',NA)) %>% 
  
  mutate(whipworm=ifelse(grepl('trichuri.*|whipworm', ID,ignore.case=T)|grepl('trichuri.*|whipworm', TI,ignore.case=T)|grepl('trichuri.*|whipworm', SO,ignore.case=T)|grepl('trichuri.*|whipworm', AB,ignore.case=T),'Whipworm',NA)) %>% 
  
  mutate(ascaris=ifelse(grepl('ascaris.*|ascariasis.*', ID,ignore.case=T)|grepl('ascaris.*|ascariasis.*', TI,ignore.case=T)|grepl('ascaris.*|ascariasis.*', SO,ignore.case=T)|grepl('ascaris.*|ascariasis.*', AB,ignore.case=T),'Ascaris',NA)) %>% 
  
  mutate(hookworm=ifelse(grepl('hookworm|ancylostoma[[:blank:]]+duodenale|necator[[:blank:]]+americanus', ID,ignore.case=T)|grepl('hookworm|ancylostoma[[:blank:]]+duodenale|necator[[:blank:]]+americanus', TI,ignore.case=T)|grepl('hookworm|ancylostoma[[:blank:]]+duodenale|necator[[:blank:]]+americanus', SO,ignore.case=T)|grepl('hookworm|ancylostoma[[:blank:]]+duodenale|necator[[:blank:]]+americanus', AB,ignore.case=T),'Hookworm',NA)) %>% 
  
  mutate(riverblindness=ifelse(grepl('onchocerc.*|onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness', ID,ignore.case=T)|grepl('onchocerc.*|onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness', TI,ignore.case=T)|grepl('onchocerc.*|onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness', SO,ignore.case=T)|grepl('onchocerc.*|onchocerca[[:blank:]]+volvulus|river[[:blank:]]+blindness', AB,ignore.case=T),'Riverblindness',NA)) %>% 
  
  mutate(lymphatic=ifelse(grepl('lymphatic[[:blank:]]+filariasis|wuchereria.*|brugia[[:blank:]]+malayi|brugia[[:blank:]]+timori', ID,ignore.case=T)|grepl('lymphatic[[:blank:]]+filariasis|wuchereria.*|brugia[[:blank:]]+malayi|brugia[[:blank:]]+timori', TI,ignore.case=T)|grepl('lymphatic[[:blank:]]+filariasis|wuchereria.*|brugia[[:blank:]]+malayi|brugia[[:blank:]]+timori', SO,ignore.case=T)|grepl('lymphatic[[:blank:]]+filariasis|wuchereria.*|brugia[[:blank:]]+malayi|brugia[[:blank:]]+timori', AB,ignore.case=T),'Lymphatic',NA)) %>% 
  
  mutate(trichinella=ifelse(grepl('trichinella', ID,ignore.case=T)|grepl('trichinella', TI,ignore.case=T)|grepl('trichinella', SO,ignore.case=T)|grepl('trichinella', AB,ignore.case=T),'Trichinella',NA)) %>% 
  
  mutate(acanthoceph=ifelse(grepl('acanthoceph*', ID,ignore.case=T)|grepl('acanthoceph*', TI,ignore.case=T)|grepl('acanthoceph*', SO,ignore.case=T)|grepl('acanthoceph*', AB,ignore.case=T),'Acanthoceph',NA)) %>% 
  
  mutate(insect=ifelse(arthropod=='Arthropod'& grepl('insect.*|[[:blank:]]+wasp.*?[[:blank:]]+|[[:blank:]]+fly[[:blank:]]+|[[:blank:]]+flies[[:blank:]]+|^wasp.*?[[:blank:]]+|[[:blank:]]+wasp\\.|[[:blank:]]+wasps\\.|^fly[[:blank:]]+|[[:blank:]]+fly\\.|^flies[[:blank:]]+|[[:blank:]]+flies\\.', DE,ignore.case=T)|arthropod=='Arthropod'& grepl('insect.*|[[:blank:]]+wasp.*?[[:blank:]]+|[[:blank:]]+fly[[:blank:]]+|[[:blank:]]+flies[[:blank:]]+|^wasp.*?[[:blank:]]+|[[:blank:]]+wasp\\.|[[:blank:]]+wasps\\.|^fly[[:blank:]]+|[[:blank:]]+fly\\.|^flies[[:blank:]]+|[[:blank:]]+flies\\.', ID,ignore.case=T)|arthropod=='Arthropod'& grepl('insect.*|[[:blank:]]+wasp.*?[[:blank:]]+|[[:blank:]]+fly[[:blank:]]+|[[:blank:]]+flies[[:blank:]]+|^wasp.*?[[:blank:]]+|[[:blank:]]+wasp\\.|[[:blank:]]+wasps\\.|^fly[[:blank:]]+|[[:blank:]]+fly\\.|^flies[[:blank:]]+|[[:blank:]]+flies\\.', TI,ignore.case=T)|grepl('insect.*', SO,ignore.case=T)|arthropod=='Arthropod'& grepl('insect.*|[[:blank:]]+wasp.*?[[:blank:]]+|[[:blank:]]+fly[[:blank:]]+|[[:blank:]]+flies[[:blank:]]+|^wasp.*?[[:blank:]]+|[[:blank:]]+wasp\\.|[[:blank:]]+wasps\\.|^fly[[:blank:]]+|[[:blank:]]+fly\\.|^flies[[:blank:]]+|[[:blank:]]+flies\\.', AB,ignore.case=T),'Insect',NA)) %>% 
  
  mutate(wasp=ifelse(grepl('[[:blank:]]+wasp.*?[[:blank:]]+|^wasp.*?[[:blank:]]+|[[:blank:]]+wasp\\.|[[:blank:]]+wasps\\.', DE,ignore.case=T)|grepl('[[:blank:]]+wasp.*?[[:blank:]]+|^wasp.*?[[:blank:]]+|[[:blank:]]+wasp\\.|[[:blank:]]+wasps\\.', ID,ignore.case=T)|grepl('[[:blank:]]+wasp.*?[[:blank:]]+|^wasp.*?[[:blank:]]+|[[:blank:]]+wasp\\.|[[:blank:]]+wasps\\.', TI,ignore.case=T)|grepl('[[:blank:]]+wasp.*?[[:blank:]]+|^wasp.*?[[:blank:]]+|[[:blank:]]+wasp\\.|[[:blank:]]+wasps\\.', SO,ignore.case=T)|grepl('[[:blank:]]+wasp.*?[[:blank:]]+|^wasp.*?[[:blank:]]+|[[:blank:]]+wasp\\.|[[:blank:]]+wasps\\.', AB,ignore.case=T),'Wasp',NA)) %>% 
  
  mutate(flies=ifelse(grepl('[[:blank:]]+fly[[:blank:]]+|[[:blank:]]+flies[[:blank:]]+|^fly[[:blank:]]+|[[:blank:]]+fly\\.|^flies[[:blank:]]+|[[:blank:]]+flies\\.', DE,ignore.case=T)|grepl('[[:blank:]]+fly[[:blank:]]+|[[:blank:]]+flies[[:blank:]]+|^fly[[:blank:]]+|[[:blank:]]+fly\\.|^flies[[:blank:]]+|[[:blank:]]+flies\\.', ID,ignore.case=T)|grepl('[[:blank:]]+fly[[:blank:]]+|[[:blank:]]+flies[[:blank:]]+|^fly[[:blank:]]+|[[:blank:]]+fly\\.|^flies[[:blank:]]+|[[:blank:]]+flies\\.', TI,ignore.case=T)|grepl('insect.*', SO,ignore.case=T)|grepl('[[:blank:]]+fly[[:blank:]]+|[[:blank:]]+flies[[:blank:]]+|^fly[[:blank:]]+|[[:blank:]]+fly\\.|^flies[[:blank:]]+|[[:blank:]]+flies\\.', AB,ignore.case=T),'Flies',NA)) %>% 
  
  mutate(arachnida=ifelse(grepl('arachnida|tick.*|lice|louse|flea.*', DE,ignore.case=T)|grepl('arachnida|tick.*|lice|louse|flea.*', ID,ignore.case=T)|grepl('arachnida|tick.*|lice|louse|flea.*', TI,ignore.case=T)|grepl('arachnida|tick.*|lice|louse|flea.*', SO,ignore.case=T)|grepl('arachnida|tick.*|lice|louse|flea.*', AB,ignore.case=T),'Arachnida',NA)) %>% 
  
  mutate(tick=ifelse(grepl('tick.*', DE,ignore.case=T)|grepl('tick.*', ID,ignore.case=T)|grepl('tick.*', TI,ignore.case=T)|grepl('tick.*', SO,ignore.case=T)|grepl('arachnida|tick.*|lice|louse|flea.*', AB,ignore.case=T),'Tick',NA)) %>% 
  
  mutate(lice=ifelse(grepl('lice|louse', DE,ignore.case=T)|grepl('lice|louse', ID,ignore.case=T)|grepl('lice|louse', TI,ignore.case=T)|grepl('lice|louse', SO,ignore.case=T)|grepl('lice|louse', AB,ignore.case=T),'Lice',NA)) %>% 
  
  mutate(flea=ifelse(grepl('flea.*', DE,ignore.case=T)|grepl('flea.*', ID,ignore.case=T)|grepl('flea.*', TI,ignore.case=T)|grepl('flea.*', SO,ignore.case=T)|grepl('flea.*', AB,ignore.case=T),'Flea',NA)) %>% 
  
  mutate(crustacea=ifelse(grepl('crustacea|pentastomida', DE,ignore.case=T)|grepl('crustacea|pentastomida', ID,ignore.case=T)|grepl('crustacea|pentastomida', TI,ignore.case=T)|grepl('crustacea|pentastomida', SO,ignore.case=T)|grepl('crustacea|pentastomida', AB,ignore.case=T),'Crustacea',NA)) %>% 
  
  mutate(pentastomida=ifelse(grepl('pentastomida', DE,ignore.case=T)|grepl('pentastomida', ID,ignore.case=T)|grepl('pentastomida', TI,ignore.case=T)|grepl('pentastomida', SO,ignore.case=T)|grepl('pentastomida', AB,ignore.case=T),'Pentastomida',NA)) %>% 
  
  #  mutate(bacteria=ifelse(grepl('bacteri.*', ID,ignore.case=T)|grepl('bacteri.*', TI,ignore.case=T)|grepl('bacteri.*', SO,ignore.case=T)|grepl('bacteri.*', AB,ignore.case=T),'Bacteria',NA)) %>% 
  
  # mutate(virus=ifelse(grepl('virus.*', ID,ignore.case=T)|grepl('virus.*', TI,ignore.case=T)|grepl('virus.*', SO,ignore.case=T)|grepl('virus.*', AB,ignore.case=T),'Virus',NA)) %>% 
  
  mutate(fungi=ifelse(grepl('fungi|fungus|microsporid.*', ID,ignore.case=T)|grepl('fungi|fungus|microsporid.*', TI,ignore.case=T)|grepl('fungi|fungus|microsporid.*', SO,ignore.case=T)|grepl('fungi|fungus|microsporid.*', AB,ignore.case=T),'Fungi',NA)) %>% 
  
  mutate(microsporid=ifelse(grepl('microsporid.*', ID,ignore.case=T)|grepl('microsporid.*', TI,ignore.case=T)|grepl('microsporid.*', SO,ignore.case=T)|grepl('microsporid.*', AB,ignore.case=T),'Microsporid',NA)) %>% 
  
  mutate(mesozoa=ifelse(grepl('mesozoa', ID,ignore.case=T)|grepl('mesozoa', TI,ignore.case=T)|grepl('mesozoa', SO,ignore.case=T)|grepl('mesozoa', AB,ignore.case=T),'Mesozoa',NA)) %>% 
  
  mutate(myxozoa=ifelse(grepl('myxozoa', ID,ignore.case=T)|grepl('myxozoa', TI,ignore.case=T)|grepl('myxozoa', SO,ignore.case=T)|grepl('myxozoa', AB,ignore.case=T),'Myxozoa',NA)) %>% 
  
  mutate(concat1 = gsub('NA','', paste0(protozoa,helminths,arthropod,other))) 

#resorting so that things that are classed in two groups are put into one when they are:
#Malaria and other (this is usually insect i.e. mosquito)
#leishmania and whatever host is carry it (usually tick but sometimes flies)
testa<-testa %>% mutate(concat1=ifelse(concat1=='ProtozoaOther' & plasmodium_malaria=='Plasmodium_malaria','Protozoa',concat1))
testa<-testa %>% mutate(concat1=ifelse(concat1=='ProtozoaArthropod' & arachnida=='Arachnida' & leishmania=='Leishmania','Protozoa',concat1))
testa<-testa %>% mutate(concat1=ifelse(concat1=='ProtozoaArthropod' & insect=='Insect' & leishmania=='Leishmania','Protozoa',concat1))
testa<-testa %>% mutate(concat1=ifelse(concat1=='ProtozoaArthropodOther'& leishmania=='Leishmania','Protozoa',concat1))
testa<-testa %>% mutate(concat1=ifelse(concat1=='HelminthsArthropod' & is.na(tick) & is.na(lice) & is.na(myxozoa) & is.na(mesozoa)& is.na(microsporid)& is.na(flea) & is.na(wasp),'Helminths',concat1))

#set valid options for first level and fill everything else with 'Other' in concat1 ~first level)
validoptions=c('Protozoa','Helminths','Arthropod','Other')  
testa$concat1[testa$concat1==""]  <- 'Other'
testa$concat1[is.na(testa$concat1)]  <- 'Other'
testa$concat1[testa$concat1=='NA']  <- 'Other'

#set to multiple species if not one of valid options
testa<-testa %>% mutate(concatfix=ifelse(!concat1%in%validoptions,'Multiple species',concat1))

#this is where it gets ugly
#it builds partial sankey plots as you move through it

#need to count per group for the sankey plot
#get first level groupings (i.e. allozyme->arthropod, allozyme->helminths etc etc) and counts
c<-testa %>% group_by(.,era,concatfix) %>% count()
#order by factor
c<-with(c, c[order(as.factor(c$era)),])
#take counts and bind with factors as numbers. Set begining number here as 0 (hence -1) for others it will be set by last value in table
test2<-do.call(rbind, Map(data.frame, A=as.numeric(as.factor(c$era))-1,B=as.numeric(as.factor(c$concatfix))+2,C=as.numeric(c$n)))
matrix1<-test2

#make names
c<-with(c, c[order(as.factor(c$era)),])
nodes=data.frame("name"=c(unique(c$era),unique(c$concatfix)))
links=as.data.frame(matrix1)
names(links) = c("source", "target", "value")

#plot
sankeyNetwork(Links = links, Nodes = nodes,
              Source = "source", Target = "target",
              Value = "value", NodeID = "name",
              fontSize= 12, nodeWidth = 20)

#arthropods#
#first lot of 3 groups
#create a list of arthropod other and new concatentation column that is from the arthrpod columsn
testa<-testa %>% mutate(arthropodother=ifelse(concatfix=='Arthropod' & is.na(insect) & is.na(arachnida) & is.na(crustacea),'Arthropod other',NA)) %>% mutate(Arthroconcat = ifelse(concatfix=='Arthropod',gsub('NA','', paste0(insect,arachnida,crustacea,arthropodother)),NA)) 

#valid arthrpod options and multispecies as before
validoptions=c('Insect',"Arthropod other",'Crustacea','Arachnida',NA)  
testa$Arthroconcat[testa$Arthroconcat==""]  <- NA
testa<-testa %>% mutate(Arthroconcat=ifelse(!Arthroconcat%in%validoptions,'Multiple species',Arthroconcat)) 

#set up table
y<-testa %>% select(Arthroconcat) %>% group_by(Arthroconcat) %>% count() %>% as.data.frame(.) %>% filter(Arthroconcat!="NA")

#arthropods are '3' in matrix1 and ending top value is 7
matrix1
y<-with(y, y[order(as.factor(y$Arthroconcat)),])
yb<-cbind(3,as.numeric(as.factor(y$Arthroconcat))+7,y$n)

#have 'mutlple species' needs to join with orginal 'multiple species' which is number 5
#change multiple species to be what it was before'5'
yb[5,2]<-5

#merge multiple species
colnames(matrix1) <- c("lev1", "lev2","countn")
colnames(yb) <- c("lev1", "lev2","countn")
matrix2<-rbind(matrix1,yb)

#add names to nodes but drop second 'mutliple species'
v<-as.data.frame(y$Arthroconcat) 
colnames(v) <- c("name")
v<-v %>% filter(name!='Multiple species')
rbind(nodes,v)
nodes=rbind(nodes,v)
links=as.data.frame(matrix2)

names(links) = c("source", "target", "value")
sankeyNetwork(Links = links, Nodes = nodes,
              Source = "source", Target = "target",
              Value = "value", NodeID = "name",
              fontSize= 12, nodeWidth = 20)

#helminths#
colnames(testa)
testa<-testa %>% mutate(helminthsother=ifelse(concatfix=='Helminths' & is.na(trematode) & is.na(monogenean) & is.na(cestode) & is.na(nematode) &is.na(acanthoceph),'Helminths other',NA)) %>% mutate(Helminthconcat = ifelse(concatfix=='Helminths',gsub('NA','', paste0(trematode,monogenean,cestode,nematode,acanthoceph,helminthsother)),NA)) 

validoptions=c('Trematode','Monogenean','Cestode','Nematode','Acanthoceph','Helminths other',NA)  
testa$Helminthconcat[testa$Helminthconcat==""]  <- NA
testa %>% select(Helminthconcat) %>% group_by(Helminthconcat) %>% count() %>% print (n=100)
testa<-testa %>% mutate(Helminthconcat=ifelse(!Helminthconcat%in%validoptions,'Multiple species',Helminthconcat)) 

#join in to matrix2
hel<-testa %>% select(Helminthconcat) %>% group_by(Helminthconcat) %>% count() %>% as.data.frame(.)  %>% filter(Helminthconcat!="NA")

#helmeths are '4'#
hel<-with(hel, hel[order(as.factor(hel$Helminthconcat)),])
helb<-hel %>% filter(Helminthconcat!='Multiple species')
helb<-cbind(4,as.numeric(as.factor(helb$Helminthconcat))+11,helb$n)

helb<-hel %>% filter(Helminthconcat=='Multiple species') %>% select(.,n) %>% cbind(4,5,.) %>% as.matrix() %>%  unname(.) %>% rbind(helb,.)
colnames(matrix2) <- c("lev1", "lev2","countn")
colnames(helb) <- c("lev1", "lev2","countn")
matrix3<-rbind(matrix2,helb)

v<-as.data.frame(hel$Helminthconcat)
colnames(v) <- c("name")
v<-v %>% filter(name!='Multiple species')

nodes=rbind(nodes,v)
links=as.data.frame(matrix3)

names(links) = c("source", "target", "value")
sankeyNetwork(Links = links, Nodes = nodes,
              Source = "source", Target = "target",
              Value = "value", NodeID = "name",
              fontSize= 12, nodeWidth = 20)

#other#
colnames(testa)
testa<-testa %>% mutate(otherother=ifelse(concatfix=='Other' & is.na(fungi) & is.na(mesozoa) & is.na(myxozoa),'Other other',NA)) %>% mutate(Otherconcat = ifelse(concatfix=='Other',gsub('NA','', paste0(fungi,mesozoa,myxozoa,otherother)),NA)) 

validoptions=c('Fungi','Mesozoa','Myxozoa','Other other',NA)  
testa$Otherconcat[testa$Otherconcat==""]  <- NA
testa %>% select(Otherconcat) %>% group_by(Otherconcat) %>% count() %>% print (n=100)
testa<-testa %>% mutate(Otherconcat=ifelse(!Otherconcat%in%validoptions,'Multiple species',Otherconcat)) 

oth<-testa %>% select(Otherconcat) %>% group_by(Otherconcat) %>% count() %>% as.data.frame(.) %>% filter(Otherconcat!="NA")
#nodes<-nodesbackup
#regrouping
oth<-oth %>% rbind(c('Myxozoa_Mesozoa',505+17))%>%filter(Otherconcat!="Myxozoa") %>%filter(Otherconcat!="Mesozoa") 
oth$n<-as.numeric(oth$n)
#others are '6'
oth<-with(oth, oth[order(as.factor(oth$Otherconcat)),])
othb<-oth %>% filter(Otherconcat!='Multiple species')
othb<-cbind(6,as.numeric(as.factor(othb$Otherconcat))+17,othb$n)
othb<-oth %>% filter(Otherconcat=='Multiple species') %>% select(.,n) %>% cbind(6,5,.) %>% as.matrix() %>%  unname(.) %>% rbind(othb,.)

colnames(matrix3) <- c("lev1", "lev2","countn")
colnames(othb) <- c("lev1", "lev2","countn")
matrix4<-rbind(matrix3,othb)

v<-as.data.frame(oth$Otherconcat)
colnames(v) <- c("name")
v<-v %>% filter(name!='Multiple species')
nodes=rbind(nodes,v)

links=as.data.frame(matrix4)

names(links) = c("source", "target", "value")
sankeyNetwork(Links = links, Nodes = nodes,
              Source = "source", Target = "target",
              Value = "value", NodeID = "name",
              fontSize= 12, nodeWidth = 20)

#protozoa#
colnames(testa)
testa<-testa %>% mutate(protozoaother=ifelse(concatfix=='Protozoa' & is.na(metamonada) & is.na(apicomplexa) & is.na(euglenozoa) &is.na(amoebozoa),'Protozoa other',NA)) %>% mutate(protozoaconcat = ifelse(concatfix=='Protozoa',gsub('NA','', paste0(metamonada,apicomplexa,euglenozoa,amoebozoa,protozoaother)),NA)) 

validoptions=c('Metamonada','Apicomplexa','Euglenozoa','Amoebozoa','Protozoa other',NA)  
testa$protozoaconcat[testa$protozoaconcat==""]  <- NA
testa %>% select(protozoaconcat) %>% group_by(protozoaconcat) %>% count() %>% print (n=100)
testa<-testa %>% mutate(protozoaconcat=ifelse(!protozoaconcat%in%validoptions,'Multiple species',protozoaconcat)) 

pro<-testa %>% select(protozoaconcat) %>% group_by(protozoaconcat) %>% count() %>% as.data.frame(.) %>% filter(protozoaconcat!="NA")
#protozoa are '7'
pro<-with(pro, pro[order(as.factor(pro$protozoaconcat)),])
prob<-pro %>% filter(protozoaconcat!='Multiple species')
prob<-cbind(7,as.numeric(as.factor(prob$protozoaconcat))+20,prob$n)
prob<-pro %>% filter(protozoaconcat=='Multiple species') %>% select(.,n) %>% cbind(7,5,.) %>% as.matrix() %>%  unname(.) %>% rbind(prob,.)
colnames(matrix4) <- c("lev1", "lev2","countn")
colnames(prob) <- c("lev1", "lev2","countn")
matrix5<-rbind(matrix4,prob)
v<-as.data.frame(pro$protozoaconcat)
colnames(v) <- c("name")
v<-v %>% filter(name!='Multiple species')
nodes=rbind(nodes,v)
links=as.data.frame(matrix5)
names(links) = c("source", "target", "value")
sankeyNetwork(Links = links, Nodes = nodes,
              Source = "source", Target = "target",
              Value = "value", NodeID = "name",
              fontSize= 12, nodeWidth = 20)


#inception to the next level

#apicomplexa#

colnames(testa)
#regrouping haemosporidi with apicomplexa other
testa<-testa %>% mutate(apicomplexaother=ifelse(concatfix=='Protozoa' & protozoaconcat=='Apicomplexa' & is.na(cryptosporidium) & is.na(toxoplasm)  & is.na(plasmodium_malaria),'Apicomplexa other',NA)) %>% mutate(apicomplexaconcat = ifelse(concatfix=='Protozoa' & protozoaconcat=='Apicomplexa',gsub('NA','', paste0(cryptosporidium,toxoplasm,plasmodium_malaria,apicomplexaother)),NA)) 

validoptions=c('Cryptosporidium','Toxoplasm','Plasmodium_malaria','Apicomplexa other',NA)  
testa$apicomplexaconcat[testa$apicomplexaconcat==""]  <- NA
testa %>% select(apicomplexaconcat) %>% group_by(apicomplexaconcat) %>% count() %>% print (n=100)
testa<-testa %>% mutate(apicomplexaconcat=ifelse(!apicomplexaconcat%in%validoptions,'Multiple species',apicomplexaconcat)) 

apic<-testa %>% select(apicomplexaconcat) %>% group_by(apicomplexaconcat) %>% count() %>% as.data.frame(.) %>% filter(apicomplexaconcat!="NA")

#apicomplexa are '22'
apic<-with(apic, apic[order(as.factor(apic$apicomplexaconcat)),])
apicb<-apic %>% filter(apicomplexaconcat!='Multiple species')
apicb<-cbind(22,as.numeric(as.factor(apicb$apicomplexaconcat))+25,apicb$n)
apicb<-apic %>% filter(apicomplexaconcat=='Multiple species') %>% select(.,n) %>% cbind(22,5,.) %>% as.matrix() %>%  unname(.) %>% rbind(apicb,.)

colnames(matrix5) <- c("lev1", "lev2","countn")
colnames(apicb) <- c("lev1", "lev2","countn")
matrix6<-rbind(matrix5,apicb)
v<-as.data.frame(apic$apicomplexaconcat)
colnames(v) <- c("name")
v<-v %>% filter(name!='Multiple species')

nodes=rbind(nodes,v)
links=as.data.frame(matrix6)

names(links) = c("source", "target", "value")
sankeyNetwork(Links = links, Nodes = nodes,
              Source = "source", Target = "target",
              Value = "value", NodeID = "name",
              fontSize= 12, nodeWidth = 20)

#euglenozoa#
colnames(testa)
testa<-testa %>% mutate(euglenozoaother=ifelse(concatfix=='Protozoa' & protozoaconcat=='Euglenozoa' & is.na(trypanosoma) & is.na(leishmania),'Euglenozoa other',NA)) %>% mutate(euglenozoaconcat = ifelse(concatfix=='Protozoa' & protozoaconcat=='Euglenozoa',gsub('NA','', paste0(trypanosoma,leishmania,euglenozoaother)),NA)) 

validoptions=c('Trypanosoma','Leishmania','Euglenozoa other',NA)  
testa$euglenozoaconcat[testa$euglenozoaconcat==""]  <- NA
testa %>% select(euglenozoaconcat) %>% group_by(euglenozoaconcat) %>% count() %>% print (n=100)
testa<-testa %>% mutate(euglenozoaconcat=ifelse(!euglenozoaconcat%in%validoptions,'Multiple species',euglenozoaconcat)) 

#just because there is only one other Im going to move it to mutliplesp to help
validoptions=c('Trypanosoma','Leishmania',NA)  
testa$euglenozoaconcat[testa$euglenozoaconcat==""]  <- NA
testa %>% select(euglenozoaconcat) %>% group_by(euglenozoaconcat) %>% count() %>% print (n=100)
testa<-testa %>% mutate(euglenozoaconcat=ifelse(!euglenozoaconcat%in%validoptions,'Multiple species',euglenozoaconcat)) 

eug<-testa %>% select(euglenozoaconcat) %>% group_by(euglenozoaconcat) %>% count() %>% as.data.frame(.) %>% filter(euglenozoaconcat!="NA")

# are '23'
eug<-with(eug, eug[order(as.factor(eug$euglenozoaconcat)),])

eugb<-eug %>% filter(euglenozoaconcat!='Multiple species')
eugb<-cbind(23,as.numeric(as.factor(eugb$euglenozoaconcat))+29,eugb$n)
eugb<-eug %>% filter(euglenozoaconcat=='Multiple species') %>% select(.,n) %>% cbind(23,5,.) %>% as.matrix() %>%  unname(.) %>% rbind(eugb,.)

colnames(matrix6) <- c("lev1", "lev2","countn")
colnames(eugb) <- c("lev1", "lev2","countn")
matrix7<-rbind(matrix6,eugb)
v<-as.data.frame(eug$euglenozoaconcat)
colnames(v) <- c("name")
v<-v %>% filter(name!='Multiple species')

nodes=rbind(nodes,v)
links=as.data.frame(matrix7)

names(links) = c("source", "target", "value")
sankeyNetwork(Links = links, Nodes = nodes,
              Source = "source", Target = "target",
              Value = "value", NodeID = "name",
              fontSize= 12, nodeWidth = 20)

#trematode
colnames(testa)
testa<-testa %>% mutate(tremotodeother=ifelse(concatfix=='Helminths' & Helminthconcat=='Trematode' & is.na(schistosoma) & is.na(fasciol),'Trematode other',NA)) %>% mutate(tremotodeconcat = ifelse(concatfix=='Helminths' & Helminthconcat=='Trematode',gsub('NA','', paste0(schistosoma,fasciol,tremotodeother)),NA)) 

validoptions=c('Schistosoma','Fasciol','Trematode other',NA)  
testa$tremotodeconcat[testa$tremotodeconcat==""]  <- NA
testa %>% select(tremotodeconcat) %>% group_by(tremotodeconcat) %>% count() %>% print (n=100)
testa<-testa %>% mutate(tremotodeconcat=ifelse(!tremotodeconcat%in%validoptions,'Multiple species',tremotodeconcat)) 

trem<-testa %>% select(tremotodeconcat) %>% group_by(tremotodeconcat) %>% count() %>% as.data.frame(.) %>% filter(tremotodeconcat!="NA")

#apicomplexa are '17'
trem<-with(trem, trem[order(as.factor(trem$tremotodeconcat)),])
tremb<-trem %>% filter(tremotodeconcat!='Multiple species')
tremb<-cbind(17,as.numeric(as.factor(tremb$tremotodeconcat))+31,tremb$n)
tremb<-trem %>% filter(tremotodeconcat=='Multiple species') %>% select(.,n) %>% cbind(17,5,.) %>% as.matrix() %>%  unname(.) %>% rbind(tremb,.)

colnames(matrix7) <- c("lev1", "lev2","countn")
colnames(tremb) <- c("lev1", "lev2","countn")
matrix8<-rbind(matrix7,tremb)
v<-as.data.frame(trem$tremotodeconcat)
colnames(v) <- c("name")
v<-v %>% filter(name!='Multiple species')

nodes=rbind(nodes,v)
links=as.data.frame(matrix8)

names(links) = c("source", "target", "value")
sankeyNetwork(Links = links, Nodes = nodes,
              Source = "source", Target = "target",
              Value = "value", NodeID = "name",
              fontSize= 12, nodeWidth = 20)

#nematode#
colnames(testa)
testa<-testa %>% mutate(nemotodeother=ifelse(concatfix=='Helminths' & Helminthconcat=='Nematode' & is.na(guineaworm) & is.na(whipworm) & is.na(ascaris) & is.na(hookworm) & is.na(riverblindness)& is.na(lymphatic) & is.na(trichinella),'Nematode other',NA)) %>% mutate(nemotodeconcat = ifelse(concatfix=='Helminths' & Helminthconcat=='Nematode',gsub('NA','', paste0(guineaworm,whipworm,ascaris,hookworm,riverblindness,lymphatic,trichinella,nemotodeother)),NA)) 

validoptions=c('Ascaris','Hookworm','Riverblindness','Lymphatic','Trichinella','Guineaworm','Nematode other','Whipworm',NA)  
testa$nemotodeconcat[testa$nemotodeconcat==""]  <- NA
testa %>% select(nemotodeconcat) %>% group_by(nemotodeconcat) %>% count() %>% print (n=100)
testa<-testa %>% mutate(nemotodeconcat=ifelse(!nemotodeconcat%in%validoptions,'Multiple species',nemotodeconcat)) 

nema<-testa %>% select(nemotodeconcat) %>% group_by(nemotodeconcat) %>% count() %>% as.data.frame(.) %>% filter(nemotodeconcat!="NA")
nema
#regrouping
#falarial & guineaworm (Lymphatic, Riverblindness & Guineaworm)
nema<-nema %>% rbind(c("Filarial&Guineaworm",40+404+321)) %>% filter(nemotodeconcat!='Lymphatic') %>% filter(nemotodeconcat!='Riverblindness') %>% filter(nemotodeconcat!='Guineaworm') %>% rbind(c('Trichinella&Whipworms',234+78)) %>% filter(nemotodeconcat!='Trichinella') %>% filter(nemotodeconcat!='Whipworm')
nema$n<-as.numeric(nema$n)
# are '16'
nema<-with(nema, nema[order(as.factor(nema$nemotodeconcat)),])
nemab<-nema %>% filter(nemotodeconcat!='Multiple species') %>% mutate()
nemab<-cbind(16,as.numeric(as.factor(nemab$nemotodeconcat))+34,nemab$n)
nemab<-nema %>% filter(nemotodeconcat=='Multiple species') %>% select(.,n) %>% cbind(16,5,.) %>% as.matrix() %>%  unname(.) %>% rbind(nemab,.)

colnames(matrix7) <- c("lev1", "lev2","countn")
colnames(nemab) <- c("lev1", "lev2","countn")
matrix9<-rbind(matrix8,nemab)
v<-as.data.frame(nema$nemotodeconcat)
colnames(v) <- c("name")
v<-v %>% filter(name!='Multiple species')
nodes=rbind(nodes,v)
links=as.data.frame(matrix9)

names(links) = c("source", "target", "value")
sankeyNetwork(Links = links, Nodes = nodes,
              Source = "source", Target = "target",
              Value = "value", NodeID = "name",
              fontSize= 12, nodeWidth = 20)

#cestode
#do we want to split cestode
#about even so lets do it for now
testa %>% filter(concatfix=='Helminths' & Helminthconcat=='Cestode') %>% nrow()
testa %>% filter(concatfix=='Helminths' & Helminthconcat=='Cestode'& echinococcus=='Echinococcus') %>% nrow()
testa %>% filter(concatfix=='Helminths' & Helminthconcat=='Cestode'& Cysticerosis=='Cysticercosis') %>% nrow()

colnames(testa)
testa<-testa %>% mutate(cestodeother=ifelse(concatfix=='Helminths' & Helminthconcat=='Cestode' & is.na(echinococcus) & is.na(Cysticerosis),'Cestode other',NA)) %>% mutate(cestodeconcat = ifelse(concatfix=='Helminths' & Helminthconcat=='Cestode',gsub('NA','', paste0(echinococcus,Cysticerosis,cestodeother)),NA)) 

validoptions=c('Echinococcus','Cysticercosis','Cestode other',NA)  
testa$cestodeconcat[testa$cestodeconcat==""]  <- NA
testa %>% select(cestodeconcat) %>% group_by(cestodeconcat) %>% count() %>% print (n=100)
testa<-testa %>% mutate(cestodeconcat=ifelse(!cestodeconcat%in%validoptions,'Multiple species',cestodeconcat)) 

cest<-testa %>% select(cestodeconcat) %>% group_by(cestodeconcat) %>% count() %>% as.data.frame(.) %>% filter(cestodeconcat!="NA")

#apicomplexa are '13'
cest<-with(cest, cest[order(as.factor(cest$cestodeconcat)),])
cestb<-cest %>% filter(cestodeconcat!='Multiple species')
cestb<-cbind(13,as.numeric(as.factor(cestb$cestodeconcat))+39,cestb$n)
cestb<-cest %>% filter(cestodeconcat=='Multiple species') %>% select(.,n) %>% cbind(13,5,.) %>% as.matrix() %>%  unname(.) %>% rbind(cestb,.)

colnames(matrix9) <- c("lev1", "lev2","countn")
colnames(cestb) <- c("lev1", "lev2","countn")
matrix10<-rbind(matrix9,cestb)
v<-as.data.frame(cest$cestodeconcat)
colnames(v) <- c("name")
v<-v %>% filter(name!='Multiple species')

nodes=rbind(nodes,v)
links=as.data.frame(matrix10)

names(links) = c("source", "target", "value")
sankeyNetwork(Links = links, Nodes = nodes,
              Source = "source", Target = "target",
              Value = "value", NodeID = "name",
              fontSize= 12, nodeWidth = 20)

#insecta
colnames(testa)
testa<-testa %>% mutate(insectother=ifelse(concatfix=='Arthropod' & Arthroconcat=='Insect' & is.na(wasp) & is.na(flies),'Insect other',NA)) %>% mutate(insectconcat = ifelse(concatfix=='Arthropod' & Arthroconcat=='Insect',gsub('NA','', paste0(wasp,flies,insectother)),NA)) 
#testa %>% filter(concatfix=='Arthropod' & Arthroconcat=='Insect')
validoptions=c('Flies','Wasp','Insect other',NA)  
testa$insectconcat[testa$insectconcat==""]  <- NA
testa %>% select(insectconcat) %>% group_by(insectconcat) %>% count() %>% print (n=100)
testa<-testa %>% mutate(insectconcat=ifelse(!insectconcat%in%validoptions,'Multiple species',insectconcat)) 

ins<-testa %>% select(insectconcat) %>% group_by(insectconcat) %>% count() %>% as.data.frame(.) %>% filter(insectconcat!="NA")

#insects are '11'
ins<-with(ins, ins[order(as.factor(ins$insectconcat)),])
insb<-ins %>% filter(insectconcat!='Multiple species')
insb<-cbind(11,as.numeric(as.factor(insb$insectconcat))+42,insb$n)
insb<-ins %>% filter(insectconcat=='Multiple species') %>% select(.,n) %>% cbind(11,5,.) %>% as.matrix() %>%  unname(.) %>% rbind(insb,.)

colnames(matrix10) <- c("lev1", "lev2","countn")
colnames(insb) <- c("lev1", "lev2","countn")
matrix11<-rbind(matrix10,insb)
v<-as.data.frame(ins$insectconcat)
colnames(v) <- c("name")
v<-v %>% filter(name!='Multiple species')

nodes=rbind(nodes,v)
links=as.data.frame(matrix11)

names(links) = c("source", "target", "value")
sankeyNetwork(Links = links, Nodes = nodes,
              Source = "source", Target = "target",
              Value = "value", NodeID = "name",
              fontSize= 12, nodeWidth = 20)


#arachida

colnames(testa)
testa<-testa %>% mutate(arachnidaother=ifelse(concatfix=='Arthropod' & Arthroconcat=='Arachnida' & is.na(tick) & is.na(lice)& is.na(flea),'Arachnida other',NA)) %>% mutate(arachnidaconcat = ifelse(concatfix=='Arthropod' & Arthroconcat=='Arachnida',gsub('NA','', paste0(tick,lice,flea,arachnidaother)),NA)) 
#testa %>% filter(concatfix=='Arthropod' & Arthroconcat=='Arachnida')
validoptions=c('Tick','Lice','Flea','Arachnida other',NA)  
testa$arachnidaconcat[testa$arachnidaconcat==""]  <- NA
testa %>% select(arachnidaconcat) %>% group_by(arachnidaconcat) %>% count() %>% print (n=100)
testa<-testa %>% mutate(arachnidaconcat=ifelse(!arachnidaconcat%in%validoptions,'Multiple species',arachnidaconcat)) 
#just because there is only one other Im going to move it to mutliplesp to help
validoptions=c('Tick','Lice','Flea',NA)  
testa$arachnidaconcat[testa$arachnidaconcat==""]  <- NA
testa %>% select(arachnidaconcat) %>% group_by(arachnidaconcat) %>% count() %>% print (n=100)
testa<-testa %>% mutate(arachnidaconcat=ifelse(!arachnidaconcat%in%validoptions,'Multiple species',arachnidaconcat)) 
arac<-testa %>% select(arachnidaconcat) %>% group_by(arachnidaconcat) %>% count() %>% as.data.frame(.)  %>% filter(arachnidaconcat!="NA")
arac

#arachnids are '8'
arac<-with(arac, arac[order(as.factor(arac$arachnidaconcat)),])
#regroup lice and flea
arac<-arac %>% rbind(c("Flea&Lice",80+60)) %>% filter(arachnidaconcat!='Flea') %>% filter(arachnidaconcat!='Lice') 
arac$n<-as.numeric(arac$n)
arac<-with(arac, arac[order(as.factor(arac$arachnidaconcat)),])


aracb<-arac %>% filter(arachnidaconcat!='Multiple species')
aracb
aracb<-cbind(8,as.numeric(as.factor(aracb$arachnidaconcat))+45,aracb$n)
aracb<-arac%>% filter(arachnidaconcat=='Multiple species') %>% select(.,n) %>% cbind(8,5,.) %>% as.matrix() %>%  unname(.) %>% rbind(aracb,.)

colnames(matrix11) <- c("lev1", "lev2","countn")
colnames(aracb) <- c("lev1", "lev2","countn")
matrix12<-rbind(matrix11,aracb)
v<-as.data.frame(arac$arachnidaconcat)
colnames(v) <- c("name")
v<-v %>% filter(name!='Multiple species')

nodes=rbind(nodes,v)
links=as.data.frame(matrix12)
names(links) = c("source", "target", "value")
sankeyNetwork(Links = links, Nodes = nodes,
              Source = "source", Target = "target",
              Value = "value", NodeID = "name",
              fontSize= 12, nodeWidth = 20)


#fungi other

colnames(testa)
testa<-testa %>% mutate(fungiaother=ifelse(concatfix=='Other' & Otherconcat=='Fungi' & is.na(microsporid) ,'Fungi other',NA)) %>% mutate(fungiconcat = ifelse(concatfix=='Other' & Otherconcat=='Fungi',gsub('NA','', paste0(microsporid,fungiaother)),NA)) 
#testa %>% filter(concatfix=='Arthropod' & Arthroconcat=='Arachnida')
validoptions=c('Microsporid','Fungi other',NA)  
testa$fungiconcat[testa$fungiconcat==""]  <- NA
testa %>% select(fungiconcat) %>% group_by(fungiconcat) %>% count() %>% print (n=100)
testa<-testa %>% mutate(fungiconcat=ifelse(!fungiconcat%in%validoptions,'Multiple species',fungiconcat)) 

matrix12
oth2<-testa %>% select(fungiconcat) %>% group_by(fungiconcat) %>% count() %>% as.data.frame(.) %>% filter(fungiconcat!="NA")

#fungi are '18'
oth2<-with(oth2, oth2[order(as.factor(oth2$fungiconcat)),])
oth2b<-oth2 %>% filter(fungiconcat!='Multiple species')
oth2b<-cbind(18,as.numeric(as.factor(oth2b$fungiconcat))+47,oth2b$n)
#no multispecies for fungi

colnames(matrix12) <- c("lev1", "lev2","countn")
colnames(oth2b) <- c("lev1", "lev2","countn")
matrix13<-rbind(matrix12,oth2b)
v<-as.data.frame(oth2$fungiconcat)
colnames(v) <- c("name")
v<-v %>% filter(name!='Multiple species')

nodes=rbind(nodes,v)
links=as.data.frame(matrix13)
names(links) = c("source", "target", "value")
sankeyNetwork(Links = links, Nodes = nodes,
              Source = "source", Target = "target",
              Value = "value", NodeID = "name",
              fontSize= 12, nodeWidth = 20)

nodesfix<-nodes
nodesfix

#fix names
nodesfix$name = gsub('Trichinella&Whipworms','Trichinella & Trichuris',nodesfix$name)
nodesfix$name = gsub('Arthropod','Arthropoda',nodesfix$name)
#nodesfix$name = gsub('Arachnid','Arachnida',nodesfix$name)
nodesfix$name = gsub('Crustacea','Crustacea',nodesfix$name)
nodesfix$name = gsub('Insect','Insecta',nodesfix$name)
nodesfix$name = gsub('Nematode','Nematoda',nodesfix$name)
nodesfix$name = gsub('Trematode','Trematoda',nodesfix$name)
nodesfix$name = gsub('Protozoa','Protists',nodesfix$name)
nodesfix$name = gsub('Cestode','Cestoda',nodesfix$name)
nodesfix$name = gsub('Myxozoa_Mesozoa','Myxozoa & Mesozoa',nodesfix$name)
nodesfix$name = gsub('Fungi','Fungi',nodesfix$name)
nodesfix$name = gsub('Wasp','Hymenoptera',nodesfix$name)
nodesfix$name = gsub('Flies','Diptera',nodesfix$name)
nodesfix$name = gsub('Flea&Lice','Siphonaptera & Phthiraptera',nodesfix$name)
nodesfix$name = gsub('Tick','Acari',nodesfix$name)
nodesfix$name = gsub('Toxoplasm','Toxoplasma',nodesfix$name)
nodesfix$name = gsub('Fasciol','Fasciola',nodesfix$name)
nodesfix$name = gsub('Plasmodium_malaria','Plasmodium',nodesfix$name)
nodesfix$name = gsub('Monogenean','Monogenea',nodesfix$name)
nodesfix$name = gsub('Microsporid','Microsporidia',nodesfix$name)
nodesfix$name = gsub('Leishmania','Leishmania',nodesfix$name)
nodesfix$name = gsub('Trypanosoma','Trypanosoma',nodesfix$name)
nodesfix$name = gsub('Euglenozoa','Euglenozoa',nodesfix$name)
nodesfix$name = gsub('Apicomplexa','Apicomplexa',nodesfix$name)
nodesfix$name = gsub('Amoebozoa','Amoebozoa',nodesfix$name)
nodesfix$name = gsub('allozyme','Allozyme period',nodesfix$name)
nodesfix$name = gsub('genomic','Genomic period',nodesfix$name)
nodesfix$name = gsub('nucleotide','Nucleotide period',nodesfix$name)
nodesfix$name = gsub('Filarial&Guineaworm','Filarial nematoda & Dracunculus',nodesfix$name)
nodesfix$name = gsub('Hookworm','Ancylostoma & Necator',nodesfix$name)
nodesfix$name = gsub('Acanthoceph','Acanthocephala',nodesfix$name)
nodesfix$name = gsub('Cysticercosis','Taenia',nodesfix$name)
#nodesfix$name = gsub('Helminths','Helminths',nodesfix$name)
nodesfix$name = gsub('Arthropods other','Arthropoda spp.',nodesfix$name)
nodesfix$name = gsub('Apicomplexans other','Apicomplexa spp.',nodesfix$name)
nodesfix$name = gsub('Fungus other','Fungi spp.',nodesfix$name)
nodesfix$name = gsub('Cestode other','Cestoda spp.',nodesfix$name)
nodesfix$name = gsub('Other','Other spp.',nodesfix$name)
nodesfix$name = gsub('Other spp. other','Other spp.',nodesfix$name)
nodesfix$name = gsub('Cryptosporidium','Cryptosporidium',nodesfix$name)
nodesfix$name = gsub('Protozoa other','Protists other',nodesfix$name)
nodesfix
links$source %>% unique()

#more interactive sankey using ploty

#node text size
txt <- list(
  family = "calibri",
  size = 18,
  color = "white",
  opacity = 1
)

#node colour
library(randomcoloR)

a<-randomColor(count = 50, hue = c(" ", "random", "red", "orange", "yellow","green", "blue", "purple", "pink", "monochrome"), luminosity = c(" ","random", "light", "bright", "dark"))

a<-randomColor(count = 50, hue = c("random"), luminosity = "bright")


p <- plot_ly(
  type = "sankey",
  orientation = "h",
  
  node = list(
    label = nodesfix$name,
    color=a ,
    pad = 17,
    thickness = 15,
    line = list(
      color = "black",
      width = 0.75
    )
  ),
  textfont = txt,
  link = list(
    source=links[,1],
    target=links[,2],
    value=links[,3] #,
  )
) %>% 
  layout(
    title = "\r\n Primary species of article"
    ,
    font = list(face="bold",
                family = "arial",
                size = 15,
                autosize = F, width = 100, height = 100#,
    )
  )

p



